package no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import no.ntnu.item.mam.utility.log.Logger;
import com.ericsson.hosasdk.api.HOSAMonitor;
import com.ericsson.hosasdk.utility.framework.FWproxy;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;

import java.awt.List;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.PropertyResourceBundle;
import no.ntnu.item.mam.utility.actors.nrg.NRGCCProcessor;
import no.ntnu.item.mam.utility.configuration.Configuration;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import com.ericsson.hosasdk.api.cc.mpccs.IpMultiPartyCallControlManager;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class NRGCallControlFeatureSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public no.ntnu.item.mam.utility.actors.nrg.NRGCCProcessor nrgMPCCProcessor;

public com.ericsson.hosasdk.api.cc.mpccs.IpMultiPartyCallControlManager mpccManager;

public java.util.HashMap notificationIDs;

public com.ericsson.hosasdk.utility.framework.FWproxy fwProxy;

public no.ntnu.item.mam.utility.log.Logger logger;

public java.util.HashMap callInfo;

public com.ericsson.hosasdk.api.HOSAMonitor hosaMonitor;

public se.ericsson.eto.norarc.ejbframe.ActorAddress myCallController;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public NRGCallControlFeatureSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("nrgcallcontrolfeature");
	//	myState = new NRGCallControlFeatureCS("NRGCallControlFeatureCS", null);
	//	currentHome = (NRGCallControlFeatureHome)(PortableRemoteObject.narrow(objectRef, NRGCallControlFeatureHome.class));
	//}

	public NRGCallControlFeatureSM() {
		myState = new NRGCallControlFeatureCS();
		currentHome = (NRGCallControlFeatureHome)(PortableRemoteObject.narrow(objectRef, NRGCallControlFeatureHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		NRGCallControlFeature ref = (NRGCallControlFeature) smr;
		try {
ref.setNrgMPCCProcessor(nrgMPCCProcessor);
ref.setMpccManager(mpccManager);
ref.setNotificationIDs(notificationIDs);
ref.setFwProxy(fwProxy);
ref.setLogger(logger);
ref.setCallInfo(callInfo);
ref.setHosaMonitor(hosaMonitor);
ref.setMyMamCallController(myCallController);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		NRGCallControlFeature sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((NRGCallControlFeatureHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((NRGCallControlFeatureHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		NRGCallControlFeature myActor = null;
		try {
			myActor = ((NRGCallControlFeatureHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		NRGCallControlFeature ref = (NRGCallControlFeature) smr;

nrgMPCCProcessor = ref.getNrgMPCCProcessor();
mpccManager = ref.getMpccManager();
notificationIDs = ref.getNotificationIDs();
fwProxy = ref.getFwProxy();
logger = ref.getLogger();
callInfo = ref.getCallInfo();
hosaMonitor = ref.getHosaMonitor();
myCallController = ref.getMyMamCallController();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	//    	set HOSAMonitor
    	this.logger = new Logger("mamLog.txt");
    	this.hosaMonitor = new HOSAMonitor();
    	this.hosaMonitor.addListener(this.logger);
    	this.callInfo = new HashMap();
    	
    	try {
			PropertyResourceBundle myResources = new PropertyResourceBundle(new FileInputStream("defaultCBCCProperties.properties"));
			this.myCallController = new ActorAddress(this.context.getParentAddress().getActorID() + "/myCallContoller", "CallController");
			
            //set FWProxy
	    	Configuration.INSTANCE.loadConfiguration("config.ini");
	    	Properties props = Configuration.INSTANCE.getProperties();
	    	this.fwProxy = new FWproxy(props);
	    	
	    	//set mpccManager
	    	this.mpccManager = (IpMultiPartyCallControlManager) this.fwProxy.obtainSCF("P_MULTI_PARTY_CALL_CONTROL");
	    	
	    	//set nrgMPCCManager
	    	this.nrgMPCCProcessor = new NRGCCProcessor(this.mpccManager, this);
	    	
	    	//this.notificationIDs = this.nrgMPCCProcessor.startNotifications(Configuration.INSTANCE.getDestinations());
	    	String [] subscribers = new String[]{myResources.getString("terminalAgentPhonenumber")};
	    	this.notificationIDs = this.nrgMPCCProcessor.startNotifications(subscribers);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	
	}
	

	
} 