package no.ntnu.item.contextengine.contextengine;

import no.ntnu.item.contextengine.controller.ContextReasoner;
import no.ntnu.item.contextengine.model.ontologyclasses.ScheduledActivity;
import no.ntnu.item.contextengine.sensors.activitysensor.ActivitySensor;
import no.ntnu.item.contextengine.sensors.locationsensor.signals.StartFetching;
import no.ntnu.item.contextengine.sensors.timesensor.TimeSensor;
import no.ntnu.item.contextengine.signals.StartUpContextEngine;
import no.ntnu.item.contextengine.signals.ContextUpdate;
import se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg;
import no.ntnu.item.contextengine.sensors.locationsensor.signals.LocationSensorRegistered;


public class ContextEngineActions extends Object {

	public static void startUpSystem(StartUpContextEngine signal, ContextEngineSM asm){
	    asm.myContextReasoner = new ContextReasoner(asm);
	    asm.myActivitySensor = new ActivitySensor(asm.myContextReasoner);
	    asm.myTimeSensor = new TimeSensor(asm.myContextReasoner);
	    asm.myContextReasoner.setTimeSensor(asm.myTimeSensor);
	    
	    // make the sensors register themselves with the Context Reasoner
	    asm.sendMessage(new StartUpContextEngine(asm.myContextReasoner, 0, 0, 0), asm.myLocationSensorAddress);
	    asm.myActivitySensor.registerWithReasoner();
	    asm.myTimeSensor.registerWithReasoner();
	    
	    asm.hour = signal.hours;
	    asm.minute = signal.minutes;
	    asm.second = signal.seconds;
	}

	public static void forwardContextUpdate(ContextUpdate signal, ContextEngineSM asm){
		String deducedActivity = signal.deducedActivity;
		String homeAvailability = signal.homeAvailability;
		String meetingRoomAvailability = signal.meetingRoomAvailability;
		String officeAvailability = signal.officeAvailability;
		System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out.println("Inside forwardContextUpdate() in ContextEngine!");
		System.out.println("Need to forward the ContextData to the User Agent");
	    System.out.println("Deduced Activity is: " + deducedActivity);
	    System.out.println("Home availability is: " + homeAvailability);
	    System.out.println("Meeting room availability is: " + meetingRoomAvailability);
	    System.out.println("Office availability is: " + officeAvailability);
	    if (deducedActivity == "" | deducedActivity == "" | deducedActivity == "" | deducedActivity == "") {
	    	System.out.println("The secondary information is in Range and will be updated in the UserProfile!!");
	    	no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile userProfile = new no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile();
		    userProfile.setDeducedActivity(deducedActivity);
		    userProfile.setHomeAvailability(homeAvailability);
		    userProfile.setOfficeAvailability(officeAvailability);
		    userProfile.setMeetingRoomAvailability(meetingRoomAvailability);
		    no.ntnu.item.serviceframe.signals.agentprofile.ProfileUpdateMsg updateMsg = new no.ntnu.item.serviceframe.signals.agentprofile.ProfileUpdateMsg(userProfile);
		    asm.sendMessage(updateMsg, asm.myProfileEditor);
	    }
	    System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
	    
	}
	

	public static void storeInformation(RoleReleaseMsg signal, ContextEngineSM asm){
	    // TODO edit action statements
		asm.myContextReasoner.store();
		asm.sendMessage(new RoleReleaseMsg(), asm.myLocationSensorAddress);
	}

	public static void startSensorFetching(LocationSensorRegistered signal, ContextEngineSM asm){
	    // start the activity sensor and the location sensor
	    asm.sendMessage(new StartFetching(asm.hour, asm.minute, asm.second), asm.myLocationSensorAddress);
	    asm.myActivitySensor.fetch(new Object());
	}



}
