package no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.nrglocationfeature;

import java.util.Properties;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import no.ntnu.item.contextengine.sensors.locationsensor.util.Configuration;
import com.ericsson.hosasdk.api.mm.ul.IpUserLocation;
import no.ntnu.item.contextengine.sensors.locationsensor.util.NRGLocationProcessor;
import com.ericsson.hosasdk.api.HOSAMonitor;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import com.ericsson.hosasdk.utility.framework.FWproxy;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import no.ntnu.item.contextengine.sensors.locationsensor.util.Logger;

public class NRGLocationFeatureSM extends ActorSM {


    public Configuration conf;
    public FWproxy fwproxy;
    public HOSAMonitor hosaMonitor;
    public IpUserLocation locationManager;
    public NRGLocationProcessor locationProcessor;
    public Logger logger;
    public FileNotFoundException myFNFException;
    public FileInputStream myFileStream;
    public IOException myIOException;
    public ActorAddress myParent;
    public PropertyResourceBundle myResources;
    public Properties props;


    /*
     * This method initializes the fields of the state machine.
     * You can edit this method inside the method body.
     * When the method is generated again, your part is copied.
     * Do not add any other methods in this class, they are not copied.
     */
    public void initialize(){
//    	set HOSAMonitor and start tracing
    	this.logger = new Logger("logFileName");
    	this.hosaMonitor = new HOSAMonitor();
    	this.hosaMonitor.addListener(this.logger);
    	
    	try {
			this.myResources = new PropertyResourceBundle(new FileInputStream("defaultProperties.properties"));
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	//dette m testes
    	this.conf = Configuration.INSTANCE;
    	this.conf.loadConfiguration("config.ini");
    	this.props = this.conf.getProperties();
    	 
    	
        
        this.myParent = this.context.getParentAddress();

        //Getting framework
        this.fwproxy = new FWproxy(this.props);

        //Getting service managers
        this.locationManager = (IpUserLocation) this.fwproxy.obtainSCF("P_USER_LOCATION");

        //Creating processors
        System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
        System.out.println("Trying to create LocationProcessor");
        this.locationProcessor = new NRGLocationProcessor(this.locationManager, this);
        System.out.println("LocationProcessor is created");
        System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    }
}
