package no.ntnu.item.contextengine.sensors.locationsensor.locationsensor;

import se.ericsson.eto.norarc.ejbframe.State;
import se.ericsson.eto.norarc.ejbframe.StateMachine;
import se.ericsson.eto.norarc.ejbactorframe.ActorCS;
import se.ericsson.eto.norarc.ejbframe.messages.ActorMsg;

public class LocationSensorCS extends ActorCS {


    protected State waitingForResponse = new se.ericsson.eto.norarc.ejbframe.State("waitingForResponse", this);
    protected State waitingForSubscriptionReports = new se.ericsson.eto.norarc.ejbframe.State("waitingForSubscriptionReports", this);
    protected State active = new se.ericsson.eto.norarc.ejbframe.State("active", this);

    public LocationSensorCS() {
        super();
    }


    public void execTrans(ActorMsg signal, State state, StateMachine curfsm){
        super.execTrans(signal, state, curfsm);
        no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorSM asm = (no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorSM) curfsm;
        if(state == idle) {
            if(signal instanceof no.ntnu.item.contextengine.signals.StartUpContextEngine) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.activate((no.ntnu.item.contextengine.signals.StartUpContextEngine) signal, asm);
                performExit(curfsm);
                nextState(active, curfsm);
            } else if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.StartPlayingMsg) {
                performExit(curfsm);
                nextState(idle, curfsm);
            }
        } else if(state == waitingForResponse) {
            if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationRes) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.receive((no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationRes) signal, asm);
                performExit(curfsm);
                nextState(waitingForResponse, curfsm);
            } else if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.TimeIsUp) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.fetchAgain(asm);
                performExit(curfsm);
                nextState(waitingForResponse, curfsm);
            } else if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.StopFetching) {
                performExit(curfsm);
                nextState(active, curfsm);
            }
        } else if(state == waitingForSubscriptionReports) {
            if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationSubscriptionReport) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.receiveSubscriptionInfo((no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationSubscriptionReport) signal, asm);
                performExit(curfsm);
                nextState(waitingForSubscriptionReports, curfsm);
            } else if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.StopSubscriptions) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.stopSubscribing((no.ntnu.item.contextengine.sensors.locationsensor.signals.StopSubscriptions) signal, asm);
                performExit(curfsm);
                nextState(active, curfsm);
            }
        } else if(state == active) {
            if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.StartFetching) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.fetch((no.ntnu.item.contextengine.sensors.locationsensor.signals.StartFetching) signal, asm);
                performExit(curfsm);
                nextState(waitingForResponse, curfsm);
            } else if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.StartSubscriptions) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.startSubscribing((no.ntnu.item.contextengine.sensors.locationsensor.signals.StartSubscriptions) signal, asm);
                performExit(curfsm);
                nextState(waitingForSubscriptionReports, curfsm);
            } else if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg) {
                no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorActions.shutDownSystem((se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg) signal, asm);
                // final state;
            }
        }
    }
}
