package no.ntnu.item.contextengine.sensors.timesensor;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.PropertyResourceBundle;
import java.util.TimeZone;
import java.util.TimerTask;

import no.ntnu.item.contextengine.controller.ContextReasoner;
import no.ntnu.item.contextengine.model.ontologyclasses.Metric;
import no.ntnu.item.contextengine.model.ontologyclasses.Time;
import no.ntnu.item.contextengine.sensors.ContextSensor;

public class TimeSensor implements ContextSensor {

	private ContextReasoner contextReasoner = null;

	public TimeSensor(ContextReasoner contextReasoner) {
		this.contextReasoner = contextReasoner;
	}
	
	/*public static void main (String[] a) {
		//String timeMetricValue = new String("06.05.2006 15:16");
		String timeMetricValue = new String("08.05.06 18:17");
		String s = "00.00.00 18:19";
		
		
		TimeSensor sensor = new TimeSensor(new ContextReasoner());
		
		Time time = new Time();
		Metric timeMetric = new Metric();
		timeMetric.setHasValue(timeMetricValue);
		time.addHasMetric(timeMetric);
		sensor.fetch(time);
		
		Time time2 = new Time();
		Metric time2Metric = new Metric();
		time2Metric.setHasValue(s);
		time2.addHasMetric(time2Metric);
		sensor.fetch(time2);
		System.out.println("At the bottom of main method");
	}*/
	
	public void registerWithReasoner() {
		this.contextReasoner.register("Time");
	}
	
	public void fetch(Object guidanceData) {
		Time timeGuidance = (Time)guidanceData;
		Metric timeMetric = (Metric)(((ArrayList)timeGuidance.getHasMetric()).get(0));
		String timeMetricValue = timeMetric.getHasValue();
		// The timeMetricValue is in the following format: 
		// Month.Day.Year hour:minute  (xx.xx.xxxx xx:xx)
		System.out.println("I'll let you know at: " + timeMetricValue);
		int day = new Integer(timeMetricValue.substring(0, 2)).intValue();
		//System.out.println("day: "+ day);
		int month = new Integer(timeMetricValue.substring(3, 5)).intValue();
		//System.out.println("MONTH: "+ month);
		int year = new Integer(timeMetricValue.substring(6, 8)).intValue();
		//System.out.println("year: "+ year);
		int hour = new Integer (timeMetricValue.substring(9, 11)).intValue();
		//System.out.println("hour: "+ hour);
		int minute = new Integer (timeMetricValue.substring(12)).intValue();
		//System.out.println("minute: "+ minute);
		
		if ((day==00) || (month== 00) || (year==00)) {
			// start the timer based on the hour and minute and today
			TimeReminder counter = new TimeReminder(this, hour, minute);
		}
		else {
			//start the timer up based on the day, month, year in addition to the hour and minute
			// as of for the demonstrator, the date will not be taken into account, only the time
			// it is assumed that as of for the simulation - the date is today...
			TimeReminder counter = new TimeReminder(this, hour, minute);
		}
	}
	
	public void receiveReminder () {
		//get the time and update this information in the ContextReasoner
		// System.out.println("Time reminder received!!!!!");
		Date now = new Date();
		DateFormat df1 = DateFormat.getDateInstance(DateFormat.SHORT);
	    DateFormat df2 = DateFormat.getTimeInstance(DateFormat.SHORT);
	    String date = df1.format(now);
	    String time = df2.format(now);
	    //System.out.println("The date is : " + date);
	    //System.out.println("The time is: " + time);
	    
	    //Format of the date (when norwegian is set as the default regional settings): 07.05.06
	    
	    //Format of the time (when norwegian is set as the default regional settings): 19:22
		
	    String dateAndTime = new String(date + " " + time);
	    // System.out.println(dateAndTime);
        
        //validate is not needed since there is no good way to validate it...
		ArrayList timeInformation = new ArrayList();
		timeInformation.add(dateAndTime);
		Time timeEntity = (Time)format(timeInformation);
		forward(timeEntity);
	}

	public Object validate(Object data) {
		/* TODO: write this into the report...
		 * The time-reminder could be validatd in two ways:
		 * 1. Check whether there is an activity at the given time.
		 *    - this takes too long and demands the sensor to check in the model
		 *    which is not desirable considering the architecture of the system
		 * 2. Check whether the time at which the reminder reminded this (NOW)
		 *    and the time the reminder was told to remind (activity_time or 
		 *    office_time_begins/ends) correspond to each other...
		 *    - this is complex.....
		 * And so, the time and time_reminding functionality will not be validated!!!! 
		 */
		return data;
	}

	public void forward(Object contextData) {
		// send the data to the ContextReasoner
		Time time = (Time)contextData; 
		this.contextReasoner.updateInformation(time);

	}

	public Object format(Collection information) {
		String timeAndDate = ((ArrayList)information).get(0).toString();
		// could also format the string value to be on the following format: xx.xx.xx xx:xx
		Time timeEntity = new Time();
		Metric timeMetric = new Metric();
		timeMetric.setHasValue(timeAndDate);
		timeEntity.addHasMetric(timeMetric);
		return timeEntity;
	}

}
