package no.ntnu.item.cbcc.cbccuseragent.callcontroller;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.PropertyResourceBundle;

import no.ntnu.item.cbcc.cbccuseragent.signals.StartUp;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.Node;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.ParseException;
import no.ntnu.item.serviceframe.auxiliar.sessiondescription.SessionDescription;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyNOKMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg;
import no.ntnu.item.mam.signals.common.RouteReq;
import no.ntnu.item.mam.signals.common.RouteRes;
import no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOKMsg;
import no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckNOKMsg;
import no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnRRReqMsg;

public class CallControllerActions extends Object {

	public static void startUp(StartUp signal, CallControllerSM asm) {
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out.println("Starting up");
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		try {
			asm.myPolicyProperties = new PropertyResourceBundle(
					new FileInputStream(new File("policies.properties")));
			int numberOfPolicies = new Integer(asm.myPolicyProperties
					.getString("numberOfPolicies")).intValue();
			// register all the activities
			String policyType = "OnRoleRequest";
			for (int i = 1; i <= numberOfPolicies; i++) {
				String policySubjectRole = asm.myPolicyProperties.getString(i
						+ "subjectRole");
				String policyDeducedActivity = asm.myPolicyProperties
						.getString(i + "deducedActivity");
				String policyHomeAvailability = asm.myPolicyProperties
						.getString(i + "homeAvailability");
				String policyOfficeAvailability = asm.myPolicyProperties
						.getString(i + "officeAvailability");
				String policyMeetingRoomAvailability = asm.myPolicyProperties
						.getString(i + "meetingRoomAvailability");
				String policyCallType = asm.myPolicyProperties.getString(i
						+ "callType");
				String policyAlternativeRole = asm.myPolicyProperties
						.getString(i + "alternativeRole");
				String policyID = i + "";
				Hashtable parameters = new Hashtable();
				String conditionText = "";
				String parametersText = "";
				// ("DEDUCED_ACTIVITY(working) AND AVAILABILITY.user(home,low)
				// AND AVAILABILITY.user(office,low) AND
				// AVAILABILITY.user(meeting-room,low)
				// AND CALLTYPE(family)\n");
				Node condition;
				String conditionString = "DEDUCED_ACTIVITY("
						+ policyDeducedActivity + ") AND CALLTYPE("
						+ policyCallType + ") AND AVAILABILITY.user("
						+ policyOfficeAvailability + ","
						+ policyHomeAvailability + ","
						+ policyMeetingRoomAvailability + "," + "r_low)\n";
				System.out
						.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
				System.out.println("The condition is: " + conditionString);
				System.out
						.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
				try {
					condition = asm.myConditionParser
							.parseCondition(conditionString);
					AddOnRRPolicyMsg msg = new AddOnRRPolicyMsg(policyID,
							policySubjectRole, policyType, condition,
							policyAlternativeRole, parameters, conditionText,
							parametersText);
					asm.sendMessage(msg, asm.myPolicyEditor);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} // end for
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void handlePolicyAddError(AddPolicyNOKMsg signal,
			CallControllerSM asm) {
		String reason = signal.reason;
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("The policy adding failed because of: ");
		 System.out.println(reason);
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
	}

	public static void handlePolicyAddSuccess(AddPolicyOkMsg signal,
			CallControllerSM asm) {
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("The policy adding succeeded");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
	}

	public static void handleRouteReq(RouteReq signal, CallControllerSM asm) {
		asm.currentCaller = signal.caller;
		asm.currentCallee = signal.callee;
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out.println("RouteReq");
		System.out.println("caller: " + asm.currentCaller);
		System.out.println("callee: " + asm.currentCallee);
		System.out.println("asm.cellphone = " + asm.cellPhone);
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		if (asm.currentCallee.equals(asm.cellPhone)) {
			//the callee of the call is the cell phone of this user agent
			String roleRequested = "cell";
			SessionDescription sessionDescription = new SessionDescription();
			String callType = null;
			if (asm.workCallers.contains(asm.currentCaller)) {
				callType = "work";
			}
			// since for the demonstrator-service the only two categories are 'work' and 'family', 
			// this check is enough
			else {
				callType = "family";
			}
			sessionDescription.setCallType(callType);
			PolicyCheckOnRRReqMsg rrMsg = new PolicyCheckOnRRReqMsg(
					roleRequested, sessionDescription);
			asm.sendMessage(rrMsg, asm.myPolicyManager);

		} else {
			// the callee of the call is not the cell phone of the user agent and will therefore 
			// not be further processed. The call will be forwarded to its original destination
			RouteRes res = new RouteRes(asm.currentCaller, asm.currentCallee);
			asm.sendMessage(res, asm.myCallControlFeature);
		}
	}

	public static void handlePolicyCheckOK(PolicyCheckOKMsg signal,
			CallControllerSM asm) {
		String roleToPlay = signal.roleType;
		String destination = null;
		String caller = asm.currentCaller;
		if (roleToPlay.equals("cell")) {
			destination = asm.cellPhone;
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			System.out.println("Forwarding the call to the cell phone");
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		} else if (roleToPlay.equals("secretary")) {
			destination = asm.secretary;
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			System.out.println("Forwarding the call to the secretary");
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		} else if (roleToPlay.equals("voicemail")) {
			destination = asm.voicemail;
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			System.out.println("Forwarding the call to the voicemail");
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		} else if (roleToPlay.equals("desk")) {
			destination = asm.deskPhone;
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			System.out.println("Forwarding the call to the desk phone");
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		} else {
			// an error occured because the role( or destination) was not recognized
			//need to forward the call to the original destination
			destination = asm.currentCallee;
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			System.out
					.println("An error occured because the role( or destination) was not recognized");
			System.out
					.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		}
		RouteRes res = new RouteRes(caller, destination);
		asm.sendMessage(res, asm.myCallControlFeature);
	}

	public static void handlePolicyCheckNOK(PolicyCheckNOKMsg signal,
			CallControllerSM asm) {
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out
				.println("An error occured when checking the role so the call will be forwarded to the original destination");
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		// need to forward the call to the original destination
		RouteRes res = new RouteRes(asm.currentCaller, asm.currentCallee);
		asm.sendMessage(res, asm.myCallControlFeature);
	}

}
