package no.ntnu.item.cbcc.cbccuseragent.callcontroller;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;

import java.lang.String;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.PolicyConditionParser;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.PropertyResourceBundle;
import java.io.IOException;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg;
import java.util.ArrayList;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.Node;
import java.io.File;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class CallControllerSM extends
		se.ericsson.eto.norarc.ejbactorframe.ActorSM {

	public se.ericsson.eto.norarc.ejbframe.ActorAddress myPolicyEditor;

	public se.ericsson.eto.norarc.ejbframe.ActorAddress myPolicyManager;

	public java.util.PropertyResourceBundle myPolicyProperties;

	public java.io.FileInputStream myFileInputStream;

	public java.io.File myFile;

	public java.util.Hashtable myHashTable;

	public java.io.FileNotFoundException myFNFException;

	public java.io.IOException ioe;

	public no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg myAoRRPmsg;

	public no.ntnu.item.serviceframe.auxiliar.policyconditionparser.Node myCondition;

	public no.ntnu.item.serviceframe.auxiliar.policyconditionparser.PolicyConditionParser myConditionParser;

	public se.ericsson.eto.norarc.ejbframe.ActorAddress myCallControlFeature;

	public java.util.ArrayList familyCallers;

	public java.util.ArrayList workCallers;

	public java.lang.String secretary;

	public java.lang.String cellPhone;

	public java.lang.String deskPhone;

	public java.lang.String voicemail;

	public java.lang.String currentCaller;

	public java.util.StringTokenizer tokenizer;

	public java.lang.String currentCallee;

	/**
	 * Constructor creates the outermost composite state, reads the actor type
	 * that this state machine implements and finds the reference to the entity
	 * bean that represents the data for this state machine. The JNDI name for
	 * the entity bean should be equal to the actor type.
	 */
	// public CallControllerSM() {
	/*
	 * It is VERY important that the the String parameter in the call to super
	 * is lower case. This is because it must match the queue name, this message
	 * driven bean will listen to. The same name must be defined in jboss.xml,
	 * look for comments in that file, and a queue must be created with the same
	 * name.
	 */
	// super("callcontroller");
	// myState = new CallControllerCS("CallControllerCS", null);
	// currentHome = (CallControllerHome)(PortableRemoteObject.narrow(objectRef,
	// CallControllerHome.class));
	// }
	public CallControllerSM() {
		myState = new CallControllerCS();
		currentHome = (CallControllerHome) (PortableRemoteObject.narrow(
				objectRef, CallControllerHome.class));
	}

	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		CallController ref = (CallController) smr;
		try {
			ref.setMyPolicyEditor(myPolicyEditor);
			ref.setMyPolicyManager(myPolicyManager);
			ref.setMyPolicyProperties(myPolicyProperties);
			ref.setMyFileInputStream(myFileInputStream);
			ref.setMyFile(myFile);
			ref.setMyHashTable(myHashTable);
			ref.setMyFNFException(myFNFException);
			ref.setIoe(ioe);
			ref.setMyAoRRPmsg(myAoRRPmsg);
			ref.setMyCondition(myCondition);
			ref.setMyConditionParser(myConditionParser);
			ref.setMyCallControlFeature(myCallControlFeature);
			ref.setFamilyCallers(familyCallers);
			ref.setWorkCallers(workCallers);
			ref.setSecretary(secretary);
			ref.setCellPhone(cellPhone);
			ref.setDeskPhone(deskPhone);
			ref.setVoicemail(voicemail);
			ref.setCurrentCaller(currentCaller);
			ref.setTokenizer(tokenizer);
			ref.setCurrentCallee(currentCallee);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
			throws RemoteException {
		CallController sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((CallControllerHome) home).create(myId, currentStateId);
			currentObject = sm;
			// Do not change myActorType in the following string!!!
			trace.traceSystem("INSTANCE CREATED: " + myId + "@" + myActorType
					+ " TIME: ?");
			// Do not change myActorType in the latter string!!!
		} catch (CreateException e1) {
			java.lang.System.out
					.println("Error when new instance created myId: " + myId
							+ "  - " + e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
	 * 
	 * @param home
	 *            The interface that identifies the actors
	 * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home) throws RemoteException {
		Collection col = null;
		try {
			col = ((CallControllerHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
	 * 
	 * @param home
	 *            The interface that identifies the actors
	 * @param myId
	 *            The actor identifier
	 * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
			throws RemoteException {
		CallController myActor = null;
		try {
			myActor = ((CallControllerHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes. Not used by the
	 * application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		CallController ref = (CallController) smr;

		myPolicyEditor = ref.getMyPolicyEditor();
		myPolicyManager = ref.getMyPolicyManager();
		myPolicyProperties = ref.getMyPolicyProperties();
		myFileInputStream = ref.getMyFileInputStream();
		myFile = ref.getMyFile();
		myHashTable = ref.getMyHashTable();
		myFNFException = ref.getMyFNFException();
		ioe = ref.getIoe();
		myAoRRPmsg = ref.getMyAoRRPmsg();
		myCondition = ref.getMyCondition();
		myConditionParser = ref.getMyConditionParser();
		myCallControlFeature = ref.getMyCallControlFeature();
		familyCallers = ref.getFamilyCallers();
		workCallers = ref.getWorkCallers();
		secretary = ref.getSecretary();
		cellPhone = ref.getCellPhone();
		deskPhone = ref.getDeskPhone();
		voicemail = ref.getVoicemail();
		currentCaller = ref.getCurrentCaller();
		tokenizer = ref.getTokenizer();
		currentCallee = ref.getCurrentCallee();

	}

	/**
	 * Initiation of the actor state machine. Not used by the application, but
	 * actor specific initiation may be done here.
	 */
	protected void initStateMachine() {
		super.initStateMachine();
		// Add part spec if XML file is not used
	}

	/**
	 * Called when immediate after this actor instance has been created. May be
	 * used for initiation of local data in instance. Note that other inner
	 * actor or other statically initiated actors has mot yet been created.
	 */
	protected void initInstance() {
		super.initInstance();
		// register the policies with the PolicyEditor
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out.println("Init'ing CallController");
		System.out
				.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		String parentID = this.context.getParentAddress().getActorID();
		this.myPolicyEditor = new ActorAddress(parentID + "/myPolicyEditor",
				"PolicyEditor");
		this.myPolicyManager = new ActorAddress(parentID + "/myPolicyManager",
				"PolicyManager");
		this.myConditionParser = new PolicyConditionParser(
				new java.io.StringReader(""));
		this.myCallControlFeature = new ActorAddress(parentID
				+ "/myCallControlFeature", "NRGCallControlFeature");
		try {
			this.familyCallers = new ArrayList();
			PropertyResourceBundle callProperties = new PropertyResourceBundle(
					new FileInputStream(new File(
							"defaultCBCCProperties.properties")));
			String familyCallers = callProperties.getString("familyCaller");
			StringTokenizer familyTok = new StringTokenizer(familyCallers);
			while (familyTok.hasMoreTokens()) {
				String familyNumber = familyTok.nextToken();
				this.familyCallers.add(familyNumber);
			}
			this.workCallers = new ArrayList();
			String workCallers = callProperties.getString("workCaller");
			StringTokenizer workTok = new StringTokenizer(workCallers);
			while (workTok.hasMoreTokens()) {
				String workNumber = workTok.nextToken();
				this.workCallers.add(workNumber);
			}
			this.secretary = callProperties.getString("secretary");
			this.cellPhone = callProperties
					.getString("terminalAgentPhonenumber");
			this.deskPhone = callProperties.getString("deskPhone");
			this.voicemail = callProperties.getString("userVoicemail");

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}