package no.ntnu.item.contextengine.contextengine;

import se.ericsson.eto.norarc.ejbframe.State;
import se.ericsson.eto.norarc.ejbframe.StateMachine;
import se.ericsson.eto.norarc.ejbactorframe.ActorCS;
import se.ericsson.eto.norarc.ejbframe.messages.ActorMsg;

public class ContextEngineCS extends ActorCS {


    protected State waitingForContextUpdates = new se.ericsson.eto.norarc.ejbframe.State("waitingForContextUpdates", this);
    protected State waitingForLocationSensorAck = new se.ericsson.eto.norarc.ejbframe.State("waitingForLocationSensorAck", this);

    public ContextEngineCS() {
        super();
    }


    public void execTrans(ActorMsg signal, State state, StateMachine curfsm){
        super.execTrans(signal, state, curfsm);
        no.ntnu.item.contextengine.contextengine.ContextEngineSM asm = (no.ntnu.item.contextengine.contextengine.ContextEngineSM) curfsm;
        if(state == idle) {
            if(signal instanceof no.ntnu.item.contextengine.signals.StartUpContextEngine) {
                no.ntnu.item.contextengine.contextengine.ContextEngineActions.startUpSystem((no.ntnu.item.contextengine.signals.StartUpContextEngine) signal, asm);
                performExit(curfsm);
                nextState(waitingForLocationSensorAck, curfsm);
            } else if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.StartPlayingMsg) {
                performExit(curfsm);
                nextState(idle, curfsm);
            }
        } else if(state == waitingForContextUpdates) {
            if(signal instanceof no.ntnu.item.contextengine.signals.ContextUpdate) {
                no.ntnu.item.contextengine.contextengine.ContextEngineActions.forwardContextUpdate((no.ntnu.item.contextengine.signals.ContextUpdate) signal, asm);
                performExit(curfsm);
                nextState(waitingForContextUpdates, curfsm);
            } else if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg) {
                no.ntnu.item.contextengine.contextengine.ContextEngineActions.storeInformation((se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg) signal, asm);
                // final state;
            }
        } else if(state == waitingForLocationSensorAck) {
            if(signal instanceof no.ntnu.item.contextengine.sensors.locationsensor.signals.LocationSensorRegistered) {
                no.ntnu.item.contextengine.contextengine.ContextEngineActions.startSensorFetching((no.ntnu.item.contextengine.sensors.locationsensor.signals.LocationSensorRegistered) signal, asm);
                performExit(curfsm);
                nextState(waitingForContextUpdates, curfsm);
            }
        }
    }
}
