package no.ntnu.item.contextengine.controller;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.PropertyResourceBundle;

public class RuleReasoner {

	private String time = null;

	private String location = null;

	private boolean scheduledActivity;

	private String deducedActivity = null;

	private String homeAvailability = null;

	private String officeAvailability = null;

	private String meetingRoomAvailability = null;

	private PropertyResourceBundle reasoningProperties = null;

	public RuleReasoner() {
		try {
			this.reasoningProperties = new PropertyResourceBundle(
					new FileInputStream("SecondaryInformationRules.properties"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void inferRule(String time, String location,
			boolean scheduledActivity) {
		int numberOfRules = new Integer(this.reasoningProperties
				.getString("numberOfRules")).intValue();
		String scheduledActivityAsString;
		this.time = time;
		this.location = location;
		this.scheduledActivity = scheduledActivity;
		// System.out.println("inferRule()");
		// System.out.println("time=" + time + " location=" + location + "
		// schAct=" + scheduledActivity);
		if (scheduledActivity) {
			scheduledActivityAsString = "true";
		} else {
			scheduledActivityAsString = "false";
		}
		for (int i = 1; i <= numberOfRules; i++) {
			String timeCandidate = this.reasoningProperties.getString(i
					+ "Time");
			String locationCandidate = this.reasoningProperties.getString(i
					+ "Location");
			String scheduledActivityCandidate = this.reasoningProperties
					.getString(i + "ScheduledActivity");
			if (timeCandidate.equals(time)
					&& locationCandidate.equals(location)
					&& scheduledActivityCandidate
							.equals(scheduledActivityAsString)) {
				// System.out.println("Found rule!!!!!");
				this.deducedActivity = this.reasoningProperties.getString(i
						+ "DeducedActivity");
				this.homeAvailability = this.reasoningProperties.getString(i
						+ "homeAvailability");
				this.officeAvailability = this.reasoningProperties.getString(i
						+ "officeAvailability");
				this.meetingRoomAvailability = this.reasoningProperties
						.getString(i + "meetingRoomAvailability");
				break;
			}// end if
		} // end for
		if (this.deducedActivity == null || this.homeAvailability == null
				|| this.officeAvailability == null
				|| meetingRoomAvailability == null) {
			// if the secondary information is not set, then all of them will be
			// declared to be nil
			// this can happen if the time, location or scheduledActivity is not
			// recognized
			// and should lead to the policy = all calls are let through...(take
			// away the service)
			this.deducedActivity = "nil";
			this.homeAvailability = "nil";
			this.officeAvailability = "nil";
			this.meetingRoomAvailability = "nil";
		}

	}

	public String getDeducedActivity() {
		return deducedActivity;
	}

	public String getHomeAvailability() {
		return homeAvailability;
	}

	public String getLocation() {
		return location;
	}

	public String getMeetingRoomAvailability() {
		return meetingRoomAvailability;
	}

	public String getOfficeAvailability() {
		return officeAvailability;
	}

	public boolean hasScheduledActivity() {
		return scheduledActivity;
	}

	public String getTime() {
		return time;
	}

}
