package no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.nrglocationfeature;

import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationRes;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationReceived;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationSubscriptionReport;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.RegisterLocationReqSubscriptions;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationReq;
import se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.StopLocationReqSubscriptions;

public class NRGLocationFeatureActions extends Object {

	public static void stop(RoleReleaseMsg signal, NRGLocationFeatureSM asm) {

		// Disposing processors
		if (asm.locationProcessor != null) {
			asm.locationProcessor.dispose();
			asm.locationProcessor = null;
		}

		//Disposing service managers
		if (asm.locationManager != null) {
			asm.fwproxy.releaseSCF(asm.locationManager);
			asm.locationManager = null;
		}

		//Disposing framework
		if (asm.fwproxy != null) {
			asm.fwproxy.endAccess();
			asm.fwproxy.dispose();
			asm.fwproxy = null;
		}

		//Stopping HOSA tracing
		asm.hosaMonitor.removeListener(asm.logger);

		// resetting all the variables 
		asm.conf = null;
		asm.logger = null;
		asm.myParent = null;
		asm.myResources = null;
		asm.props = null;

	}

	public static void requestLocation(FetchLocationReq signal,
			NRGLocationFeatureSM asm) {
		if (asm.locationProcessor == null) {
			throw new RuntimeException("The application is not started.");
		}
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("Trying to send location request");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
		asm.locationProcessor.requestLocation(signal.users);
	}

	public static void forwardLocation(LocationReceived signal,
			NRGLocationFeatureSM asm) {
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("LocationValueObject results received this time!!!!!!!!!!!");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("send this information to my parent!!! " + asm.myParent);*/
		asm.sendMessage(new FetchLocationRes(signal.resultList), asm.myParent);
	}

	public static void registerLocationRequests(
			RegisterLocationReqSubscriptions signal, NRGLocationFeatureSM asm) {
		if (asm.locationProcessor == null) {
			throw new RuntimeException("The application is not started.");
		}
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("Registering subscriptions");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
		asm.locationProcessor
				.registerLocationRequestSubscriptions(signal.users);
	}

	public static void forwardLocationReport(LocationSubscriptionReport signal,
			NRGLocationFeatureSM asm) {
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("LocationValueObject report received!!!!!!!!!!!");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
		asm.sendMessage(new FetchLocationRes(signal.resultList), asm.myParent);
	}

	public static void stopSubscriptions(StopLocationReqSubscriptions signal,
			NRGLocationFeatureSM asm) {
		if (asm.locationProcessor == null) {
			throw new RuntimeException("The application is not started.");
		}
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("Stopping subscriptions");
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
		asm.locationProcessor.stopLocationRequestSubscriptions(signal.users);
	}

}
