package no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.nrglocationfeature;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;

import java.util.Properties;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import no.ntnu.item.contextengine.sensors.locationsensor.util.Configuration;
import com.ericsson.hosasdk.api.mm.ul.IpUserLocation;
import no.ntnu.item.contextengine.sensors.locationsensor.util.NRGLocationProcessor;
import com.ericsson.hosasdk.api.HOSAMonitor;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import com.ericsson.hosasdk.utility.framework.FWproxy;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import no.ntnu.item.contextengine.sensors.locationsensor.util.Logger;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class NRGLocationFeatureSM extends
		se.ericsson.eto.norarc.ejbactorframe.ActorSM {

	public no.ntnu.item.contextengine.sensors.locationsensor.util.Configuration conf;

	public com.ericsson.hosasdk.utility.framework.FWproxy fwproxy;

	public com.ericsson.hosasdk.api.HOSAMonitor hosaMonitor;

	public com.ericsson.hosasdk.api.mm.ul.IpUserLocation locationManager;

	public no.ntnu.item.contextengine.sensors.locationsensor.util.NRGLocationProcessor locationProcessor;

	public no.ntnu.item.contextengine.sensors.locationsensor.util.Logger logger;

	public java.io.FileNotFoundException myFNFException;

	public java.io.FileInputStream myFileStream;

	public java.io.IOException myIOException;

	public se.ericsson.eto.norarc.ejbframe.ActorAddress myParent;

	public java.util.PropertyResourceBundle myResources;

	public java.util.Properties props;

	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public NRGLocationFeatureSM() {
	/*
	 * It is VERY important that the the String parameter in the call to super is lower
	 * case. This is because it must match the queue name, this message driven bean will
	 * listen to. The same name must be defined in jboss.xml, look for comments in that
	 * file, and a queue must be created with the same name.
	 */
	//	super("nrglocationfeature");
	//	myState = new NRGLocationFeatureCS("NRGLocationFeatureCS", null);
	//	currentHome = (NRGLocationFeatureHome)(PortableRemoteObject.narrow(objectRef, NRGLocationFeatureHome.class));
	//}
	public NRGLocationFeatureSM() {
		myState = new NRGLocationFeatureCS();
		currentHome = (NRGLocationFeatureHome) (PortableRemoteObject.narrow(
				objectRef, NRGLocationFeatureHome.class));
	}

	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		NRGLocationFeature ref = (NRGLocationFeature) smr;
		try {
			ref.setConf(conf);
			ref.setFwproxy(fwproxy);
			ref.setHosaMonitor(hosaMonitor);
			ref.setLocationManager(locationManager);
			ref.setLocationProcessor(locationProcessor);
			ref.setLogger(logger);
			ref.setMyFNFException(myFNFException);
			ref.setMyFileStream(myFileStream);
			ref.setMyIOException(myIOException);
			ref.setMyParent(myParent);
			ref.setMyResources(myResources);
			ref.setProps(props);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
			throws RemoteException {
		NRGLocationFeature sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((NRGLocationFeatureHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem("INSTANCE CREATED: " + myId + "@" + myActorType
					+ " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out
					.println("Error when new instance created myId: " + myId
							+ "  - " + e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
	 * @param home The interface that identifies the actors
	 * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home) throws RemoteException {
		Collection col = null;
		try {
			col = ((NRGLocationFeatureHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
	 * @param home The interface that identifies the actors
	 * @param myId The actor identifier
	 * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
			throws RemoteException {
		NRGLocationFeature myActor = null;
		try {
			myActor = ((NRGLocationFeatureHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
	 * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		NRGLocationFeature ref = (NRGLocationFeature) smr;

		conf = ref.getConf();
		fwproxy = ref.getFwproxy();
		hosaMonitor = ref.getHosaMonitor();
		locationManager = ref.getLocationManager();
		locationProcessor = ref.getLocationProcessor();
		logger = ref.getLogger();
		myFNFException = ref.getMyFNFException();
		myFileStream = ref.getMyFileStream();
		myIOException = ref.getMyIOException();
		myParent = ref.getMyParent();
		myResources = ref.getMyResources();
		props = ref.getProps();

	}

	/**
	 * Initiation of the actor state machine.
	 * Not used by the application, but actor specific initiation may be done here.
	 */
	protected void initStateMachine() {
		super.initStateMachine();
		//Add part spec if XML file is not used 
	}

	/**
	 * Called when immediate after this actor instance has been created.
	 * May be used for initiation of local data in instance. Note that other inner
	 * actor or other statically initiated actors has mot yet been created.
	 */
	protected void initInstance() {
		super.initInstance();
		//    	set HOSAMonitor and start tracing
		this.logger = new Logger("logFileName");
		this.hosaMonitor = new HOSAMonitor();
		this.hosaMonitor.addListener(this.logger);

		try {
			this.myResources = new PropertyResourceBundle(new FileInputStream(
					"defaultContextEngineProperties.properties"));

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		//dette m testes
		this.conf = Configuration.INSTANCE;
		this.conf.loadConfiguration("config.ini");
		this.props = this.conf.getProperties();

		this.myParent = this.context.getParentAddress();

		//Getting framework
		this.fwproxy = new FWproxy(this.props);

		//Getting service managers
		this.locationManager = (IpUserLocation) this.fwproxy
				.obtainSCF("P_USER_LOCATION");

		//Creating processors
		System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		System.out.println("Trying to create LocationProcessor");
		this.locationProcessor = new NRGLocationProcessor(this.locationManager,
				this);
		System.out.println("LocationProcessor is created");
		System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
	}

}