package no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.sim;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.EJBObject;
import javax.ejb.Handle;
import javax.ejb.RemoveException;

import se.ericsson.eto.norarc.ejbactorframe.ActorContext;
import se.ericsson.eto.norarc.ejbframe.MailBox;
import no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensor;
import no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorBean;



/**
 * This class is necessary for simulation to work. Simply copy and paste the
 * class for it to work. All you need to change is name of the class and what it
 * extends and implements. The class should extend your actorbean (in the example
 * LocationSensorBean), and it should implement your Actor interface (in this example LocationSensor).
 * 
 * Since the class implements the LocationSensor interface, all business methods of the 
 * interface must be implemented here as well.
 * 
 * The class overrides the EJB specific methods of your Actor, enabling simulation
 * outside an EJB container.
 */
public class SimLocationSensorBean extends LocationSensorBean implements LocationSensor {

	/*
	 * Implement local data and abstract methods from Bean classes
	 */

    /** Local persistent data for the actor */
    

public se.ericsson.eto.norarc.ejbframe.ActorAddress myLocationFeatureAddress;

public no.ntnu.item.contextengine.controller.ContextReasoner myContextReasoner;

public no.ntnu.item.contextengine.sensors.timesensor.TimeReminder myTimer;

public int hourInterval;

public int minuteInterval;

public int secondInterval;

public se.ericsson.eto.norarc.ejbframe.ActorAddress myContextEngine;
  	


public se.ericsson.eto.norarc.ejbframe.ActorAddress getMyLocationFeatureAddress(){
	return myLocationFeatureAddress;
}

public void setMyLocationFeatureAddress(se.ericsson.eto.norarc.ejbframe.ActorAddress myLocationFeatureAddress){
	this.myLocationFeatureAddress = myLocationFeatureAddress;
}

public no.ntnu.item.contextengine.controller.ContextReasoner getMyContextReasoner(){
	return myContextReasoner;
}

public void setMyContextReasoner(no.ntnu.item.contextengine.controller.ContextReasoner myContextReasoner){
	this.myContextReasoner = myContextReasoner;
}

public no.ntnu.item.contextengine.sensors.timesensor.TimeReminder getMyTimer(){
	return myTimer;
}

public void setMyTimer(no.ntnu.item.contextengine.sensors.timesensor.TimeReminder myTimer){
	this.myTimer = myTimer;
}

public int getHourInterval(){
	return hourInterval;
}

public void setHourInterval(int hourInterval){
	this.hourInterval = hourInterval;
}

public int getMinuteInterval(){
	return minuteInterval;
}

public void setMinuteInterval(int minuteInterval){
	this.minuteInterval = minuteInterval;
}

public int getSecondInterval(){
	return secondInterval;
}

public void setSecondInterval(int secondInterval){
	this.secondInterval = secondInterval;
}

public se.ericsson.eto.norarc.ejbframe.ActorAddress getMyContextEngine(){
	return myContextEngine;
}

public void setMyContextEngine(se.ericsson.eto.norarc.ejbframe.ActorAddress myContextEngine){
	this.myContextEngine = myContextEngine;
}
  	
  	
	// The rest of the class is a pattern for ActorBean simulation. Do not edit

  /** EJBActorFramework simulation - not used by application */
  public ActorContext context;
  /** EJBActorFramework simulation - not used by application */
	public String currentStateId;
  /** EJBActorFramework simulation - not used by application */
	public MailBox saveQueue;
  /** EJBActorFramework simulation - not used by application */
	public int traceCategories;
  /** EJBActorFramework simulation - not used by application */
	public int traceLev;
  /** EJBActorFramework simulation - not used by application */
	public String myActorId;
  /** EJBActorFramework simulation - not used by application */
	public Hashtable activeTimers;

  /** EJBActorFramework simulation - not used by application */
	public SimLocationSensorBean(String currentStateId, String myActorId) {
		this.currentStateId = currentStateId;
		this.myActorId = myActorId;
	}

  /** EJBActorFramework simulation - not used by application */
  public ActorContext getContext() {
		return context;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setContext(ActorContext context) {
		this.context = context;
	}

  /** EJBActorFramework simulation - not used by application */
	public String getMyActorId() {
		return myActorId;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setMyActorId(String myId) {
		this.myActorId = myId;
	}

  /** EJBActorFramework simulation - not used by application */
	public String getCurrentStateId() {
		return currentStateId;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setCurrentStateId(String currentStateId) {
		this.currentStateId = currentStateId;
	}

  /** EJBActorFramework simulation - not used by application */
	public MailBox getSaveQueue() {
		return saveQueue;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setSaveQueue(MailBox saveQueue) {
		this.saveQueue = saveQueue;
	}

  /** EJBActorFramework simulation - not used by application */
	public int getTraceCategories() {
		return traceCategories;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setTraceCategories(int traceCategories) {
		this.traceCategories = traceCategories;
	}

  /** EJBActorFramework simulation - not used by application */
	public int getTraceLev() {
		return traceLev;
	}

  /** EJBActorFramework simulation - not used by application */
	public void setTraceLev(int traceLev) {
		this.traceLev = traceLev;
	}

  /** EJBActorFramework simulation - not used by application */
  public Hashtable getActiveTimers() {
    return this.activeTimers;
  }

  /** EJBActorFramework simulation - not used by application */
  public void setActiveTimers(Hashtable activeTimers) {
    this.activeTimers = activeTimers;
  }

  /** EJBActorFramework simulation - not used by application */
	public String ejbCreate(String myId, String stateId)
		throws CreateException {
		setMyActorId(myId);
		setCurrentStateId(stateId);
		//        setSaveQueue(null);
		return null;
	}

	//Dummy methods for EJB interfacing

  /** EJB simulation - not used by application */
	public EJBHome getEJBHome() throws RemoteException {
		return null;
	}

  /** EJB simulation - not used by application */
	public Object getPrimaryKey() throws RemoteException {
		return null;
	}

  /** EJB simulation - not used by application */
	public void remove() throws RemoteException, RemoveException {}

  /** EJB simulation - not used by application */
	public Handle getHandle() throws RemoteException {
		return null;
	}

  /** EJB simulation - not used by application */
	public boolean isIdentical(EJBObject ejbObject) throws RemoteException {
		return false;
	}

}
 
 