package no.ntnu.item.contextengine.sensors.locationsensor.util;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import com.ericsson.hosasdk.api.HOSAAdapter;

public class Logger extends HOSAAdapter {
	
	FileWriter writer = null;
	BufferedWriter bw = null;
	
	public Logger (String logFile) {
		initialize(logFile);
	}
	
	private void initialize (String logFile) {
		try {
			this.writer = new FileWriter(logFile, true);
			bw = new BufferedWriter(this.writer);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**For testing purposes*/
	/*public static void main(String[] args) {
		Logger l = new Logger();
		l.initialize();
		l.write("linje 1");
		l.write("linje 2");
		l.write("linje 3");
		l.terminate();
	}*/
	
	private void write (String text) {
		try {
	        bw.write(text);
	        bw.write(System.getProperty("line.separator"));
	        bw.write(System.getProperty("line.separator"));
	    } 
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void terminate () {
		try {
			bw.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void receivedRequest(Object aTarget, String aMethod, Object[] aArguments) {
		System.out.println("Logging..................");
		String text = new String ("Request received: target " + aTarget + " method invoked " + aMethod + " with arguments " + aArguments);
		write(text);
	}
	
	public void sendingRequest(Object aTarget, String aMethod, Object[] aArguments) {
		System.out.println("Logging..................");
		String text = new String ("Request sent: target " + aTarget + " method invoked " + aMethod + " with arguments " + aArguments);
		write(text);
	}
	
	public void receivedResponse(Object aTarget, String aMethod, Object[] aArguments, Object aReturnValue) {
		System.out.println("Logging..................");
		String text = new String ("Received Response: target " + aTarget + " method invoked " + aMethod + " arguments " + aArguments + " return value " + aReturnValue);
		write(text);
	}
	
	public void sendingResponse(Object aTarget, String aMethod, Object[] aArguments, Object aReturnValue) {
		System.out.println("Logging..................");
		String text = new String ("Response sent: target " + aTarget + " Method invoked " + aMethod + " with arguments " + aArguments + " return value " + aReturnValue);
		write(text);
	}
	
	

}
