package no.ntnu.item.contextengine.sensors.timesensor;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Timer;
import java.util.TimerTask;

import no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.LocationSensorSM;
import no.ntnu.item.contextengine.sensors.locationsensor.signals.TimeIsUp;

/**
 * Counts down towards a given time.
 */

public class TimeReminder {

	Timer timer = null;

	protected TimeSensor sensor = null;

	protected LocationSensorSM locationSensor = null;

	public TimeReminder(TimeSensor sensor, int day, int month, int year,
			int hour, int minute) {
		this.sensor = sensor;
		//Get the Date corresponding to the time and date provided
		Calendar calendar = Calendar.getInstance();
		calendar.set(Calendar.YEAR, year);
		calendar.set(Calendar.MONTH, month);
		calendar.set(Calendar.DAY_OF_MONTH, day);
		calendar.set(Calendar.HOUR_OF_DAY, hour);
		calendar.set(Calendar.MINUTE, minute);
		Date time = calendar.getTime();

		timer = new Timer();
		timer.schedule(new TimeReminderTask(this.sensor), time);

	}

	public TimeReminder(TimeSensor sensor, int hour, int minute) {
		this.sensor = sensor;
		//Get the Date corresponding to the time today.
		Calendar calendar = Calendar.getInstance();
		/* This should not be necessary since the calendar is instatiated with
		 * the current time and date
		 * int year = Calendar.YEAR;
		 int month = Calendar.MONTH;
		 int day = Calendar.DAY_OF_MONTH;
		 calendar.set(Calendar.YEAR, year);
		 calendar.set(Calendar.MONTH, month);
		 calendar.set(Calendar.DAY_OF_MONTH, day);*/

		calendar.set(Calendar.HOUR_OF_DAY, hour);
		calendar.set(Calendar.MINUTE, minute);
		calendar.set(Calendar.SECOND, 0);
		Date time = calendar.getTime();

		timer = new Timer();
		timer.schedule(new TimeReminderTask(this.sensor), time);

	}

	class TimeReminderTask extends TimerTask {

		TimeSensor sensor = null;

		public TimeReminderTask(TimeSensor sensor) {
			this.sensor = sensor;
		}

		public void run() {
			/*System.out.println("Inside run() in TimeReminder...");
			Date now = new Date();
			DateFormat df2 = DateFormat.getTimeInstance(DateFormat.SHORT);
			String time = df2.format(now);
			System.out.println("The time is: " + time);*/
			this.sensor.receiveReminder();
			timer.cancel(); //Terminate the timer thread
		}
	}

	public TimeReminder(LocationSensorSM locationSensor, int seconds) {
		this.locationSensor = locationSensor;

		timer = new Timer();
		timer.schedule(new TimeReminderLocation(this.locationSensor),
				seconds * 1000);

	}

	class TimeReminderLocation extends TimerTask {
		LocationSensorSM locationSensor = null;

		public TimeReminderLocation(LocationSensorSM locationSensor) {
			this.locationSensor = locationSensor;
		}

		public void run() {
			this.locationSensor.sendMessage(new TimeIsUp(), this.locationSensor
					.getMyActorAddress());
			timer.cancel();
		}
	}
}