package no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature;

import java.util.ArrayList;
import java.util.Iterator;

import com.ericsson.hosasdk.api.TpAddress;
import com.ericsson.hosasdk.api.cc.mpccs.TpCallLegIdentifier;
import com.ericsson.hosasdk.api.cc.mpccs.TpMultiPartyCallIdentifier;

import no.ntnu.item.mam.signals.ccnrgedgeservice.HandleCall;
import no.ntnu.item.mam.signals.common.RouteReq;
import no.ntnu.item.mam.signals.common.RouteRes;
import se.ericsson.eto.norarc.ejbactorframe.messages.RoleReleaseMsg;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;

public class NRGCallControlFeatureActions extends Object {

	public static void handleCall(HandleCall signal, NRGCallControlFeatureSM asm) {
		//TpMultiPartyCallIndetifier acall - the identifier of the call in progress 
		//TpCallLegIdentifier afirstLeg - the firstLeg of the call
		//get a string representation of the caller's and callee's phonenumber
		String caller = signal.anOriginatingAddress.AddrString;
		String callee = signal.aDestinationAddress.AddrString;

		//adds the call information to callInfo list in the statemachine
		ArrayList info = new ArrayList();
		info.add(0, signal.aCall);
		info.add(1, signal.aFirstLeg);
		info.add(2, signal.anOriginatingAddress);
		asm.callInfo.put(caller, info);

		//send beskjed til mamCC-modul og sprre om hvor anropet skal rutes
		//asm.sendMessage(new RequestRoute(caller, callee), new ActorAddress("id_paa_denne", "mamCallController"));
		//since all of these objects are needed, I think that they should be forwarded all the way
		//ask, based on destinationAddress and originatingAddress, mamCallController where to route the call
		//wait for answer
		//when answer is returned:
		//1. invoke asm.mpccProcessor.route(aCall, originatingAddress, destinationAddress)
		//2. invoke asm.mpccProcessor.continueProcessing(afirstLeg)
		//3. invoke asm.mpccProcessor.deassign(aCall)
		/*System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		 System.out.println("Trying to send a RouteReq to the callController with the address: " + asm.myCallController);
		 System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");*/
		String callControllerID = asm.context.getParentAddress().getActorID()
				+ "/myCallController";
		asm.sendMessage(new RouteReq(caller, callee), new ActorAddress(
				callControllerID, "CallController")/*asm.myCallController*/);
	}

	public static void routeCall(RouteRes signal, NRGCallControlFeatureSM asm) {
		String caller = signal.caller;
		String destination = signal.destination;
		ArrayList additionalCallInfo = null;
		//this try catch block is not really necessary, except when simulating the code in Ramses
		//For now, ignore this!!
		try {
			additionalCallInfo = (ArrayList) asm.callInfo.get(caller);
			//abort the call if no destination could be determined
			//this should never happen
			if (destination == null) {
				// terminate the call
				System.out
						.println("Could not find a destination. The call was therefore aborted");
				asm.nrgMPCCProcessor
						.release((TpMultiPartyCallIdentifier) additionalCallInfo
								.get(0));
			}
			//a (valid) destination was determined
			else {
				// reroute the call
				TpAddress source = (TpAddress) additionalCallInfo.get(2);
				asm.nrgMPCCProcessor.route(
						(TpMultiPartyCallIdentifier) additionalCallInfo.get(0),
						source, destination);

				// cancel suspension of first leg
				asm.nrgMPCCProcessor
						.continueProcessing((TpCallLegIdentifier) additionalCallInfo
								.get(1));

				// the application is no longer interested,
				// so disconnect the association between Ericsson Network Resource Gateway and the network
				asm.nrgMPCCProcessor
						.deassign((TpMultiPartyCallIdentifier) additionalCallInfo
								.get(0));

			}
		} catch (NullPointerException np) {
			//this will only happen when simulating in Ramses, ignore this code-block
			np.printStackTrace();
		}

		//delete the information about the call, this is no longer needed
		asm.callInfo.remove(caller);

	}

	public static void releaseNRGConnection(RoleReleaseMsg signal,
			NRGCallControlFeatureSM asm) {
		//stopping notifications
		Iterator iterator = asm.notificationIDs.values().iterator();
		while (iterator.hasNext()) {
			Integer notificationID = (Integer) iterator.next();
			asm.nrgMPCCProcessor.stopNotifications(notificationID.intValue());
		}

		//disposing nrgMPCCProcessor
		asm.nrgMPCCProcessor.dispose();

		//disposing services
		if (asm.nrgMPCCProcessor != null) {
			asm.fwProxy.releaseSCF(asm.mpccManager);
		}

		//disposing framework
		if (asm.fwProxy != null) {
			asm.fwProxy.endAccess();
			asm.fwProxy.dispose();
		}

		//stopping HOSA-tracing
		asm.hosaMonitor.removeListener(asm.logger);
	}

}
