package no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature.sim;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Timer;
import java.util.TimerTask;

import javax.ejb.EJBHome;

import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import se.ericsson.eto.norarc.ejbframe.Simulator;
import se.ericsson.eto.norarc.ejbframe.StateData;
import se.ericsson.eto.norarc.ejbframe.messages.ActorMsg;
import se.ericsson.eto.norarc.ejbframe.messages.TimerMsg;
import se.ericsson.eto.norarc.ejbframe.Scheduler;

import no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature.NRGCallControlFeature;
import no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature.NRGCallControlFeatureSM;

/**
 * This class is necessary for simulation to work. Simply copy and paste the
 * class for it to work. All you need to change is name of the class and what it
 * extends. This class should extend your SM class, in this example the useragenttestSM
 * class.
 * 
 * The class overrides the EJB specific methods of your Actor, enabling simulation
 * outside an EJB container.
 */
public class SimNRGCallControlFeatureSM extends NRGCallControlFeatureSM {
  /** EJBActorFramework simulation - not used by application */
	Hashtable stateData = new Hashtable();
  /** EJBActorFramework simulation - not used by application */
	protected static Timer jfTimer = new Timer();
  /** EJBActorFramework simulation - not used by application */
	// protected Hashtable activeTimers = new Hashtable();

  /** EJBActorFramework simulation - not used by application */
	  public class JFTimerTask extends TimerTask {
		  TimerMsg thisMsg;

		  public JFTimerTask(TimerMsg thisMsg) {
		    super();
		    thisMsg.setReceiverRole(context.getActorAddress());
		    this.thisMsg = thisMsg;
		  }

		  public void run() {
		    sendMessage(thisMsg);
		    activeTimers.remove(thisMsg.toString());
		  }
	  }

  /** 
   * Create and start a timer that will elapse as a received signal
   * @param tm The timer message object 
   * @param duration The time to elapse, specified in milliseconds
   * @param Specifying the timer identifier
   * @return Timer unique identifier (to use for stopping timer)
   */
    public void startTimer(TimerMsg tm, long duration, String timerId) {
        if (timerId == null || timerId.equalsIgnoreCase("")) {
            timerId = tm.toString();
        }
        JFTimerTask jfTT = new JFTimerTask(tm);
        activeTimers.put(timerId, jfTT);
        jfTimer.schedule(jfTT, duration);
        return;
    }

  /** 
   * Stop a timer that has been started by the 'startTimer()' method.
   * @param tm Identifier of the timer to be stopped 
   */
	public void stopTimer(String tm) {
		JFTimerTask t = (JFTimerTask) activeTimers.remove(tm);
    trace.traceTask("Timer: " + tm.trim() + " removed");
		t.cancel();
	}

  /** EJBActorFramework simulation - not used by application */
	public SimNRGCallControlFeatureSM() {

	}

  /** EJBActorFramework simulation - not used by application */
	protected void initJMS(){};

	/**
	 * Create an new actor instance
	 * @param home Reference to the home interface
	 * @param myId The instance id
	 */
	protected void createInstance(EJBHome home, String myId) throws RemoteException {
		NRGCallControlFeature sm = null;
		currentStateId = initialState.stateName(); // initial state contains the initial State set at creation
		sm = new SimNRGCallControlFeatureBean(currentStateId, myActorId);
		currentObject = sm; // store the referance to the entity beans remote / local  class
		// iniate this state machine's state data
		//myProfile = new NRGCallControlFeatureProfile("geir","melby","45249491");
		// end of iniate this state machine's state data
	}

  /** Find and return state data for all actor instances.
   * NOTE: has not been used yet.
   * @param home The home interface for identification of the actor set 
   * @return Found actors state data */
	protected Collection findAllInstances(EJBHome home) throws RemoteException {
		return stateData.values();
	}

  /** Find state data for a specific actor instance.
   * NOTE: has not been used yet.
   * @param home The home interface for identification of the actor set 
   * @param myId The actor identifier
   * @return Found actor state data */
	protected StateData findEntityBean(EJBHome home, String myId) throws RemoteException {
		return (StateData)stateData.get(myId);
	}

  /** Not to be used by application */
	protected void storeData(StateData smr){
		super.storeData(smr);
		stateData.put(this.myActorId,smr);
	}

  /** Not to be used by application */
	protected void initStateMachine() {
		super.initStateMachine();
	}

  /** Not to be used by application */
  public void removeInstance() {
	  stateData.remove(myActorId);
  }

  /** Not to be used by application. Use 'sendMessage()' in stead */
  public final void output(ActorMsg sig) {
 /*	  if(sig.getReceiverRole() != null && sig.getReceiverRole().getActorType() != null) {
  	  String queueName = "queue/" + sig.getReceiverRole().getActorType();
  	  sig.setSenderRole(new ActorAddress(myActorId, myActorType)); // set the sender of this message
  	  if (mailbox!= null) {
  		  Object s = Simulator.mySystem.get(sig.getReceiverRole().getActorType());
  		  if (s != null) {
  			  mailbox.addMessage(sig);
  		  } else {
  			  sig.setReceiverRole(new ActorAddress("env-cas", "env"));
  			  mailbox.addMessage(sig);
  		  }
  	  } else {
  		trace.traceSystem("mailbox not initiated");
  	  }
  	  trace.traceOutput(sig);
  	} else {
  	  trace.traceSystem("ActorType or ReceiverRole is null, signal not sent.");
  	}
  	*/
  	Scheduler.output(sig, this);
  }

  /** Not to be used by application. Use 'sendMessage()' in stead */
  public void startTransaction() {
     // not supported in sim version
  }

  /** Not to be used by application. Use 'sendMessage()' in stead */
  public void endTransaction() {
      // not supported in sim version
  }
  public String getActorDeployDir() {
     return java.lang.System.getProperty("user.dir")+"\\actordeploy\\";
 }
}