package no.ntnu.item.serviceframe.actors.policymanagement.policyeditor;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import java.util.Hashtable;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class PolicyEditorSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public se.ericsson.eto.norarc.ejbframe.ActorAddress requestorSessionRole;

public java.util.Hashtable knownRoles;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public PolicyEditorSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("policyeditor");
	//	myState = new PolicyEditorCS("PolicyEditorCS", null);
	//	currentHome = (PolicyEditorHome)(PortableRemoteObject.narrow(objectRef, PolicyEditorHome.class));
	//}

	public PolicyEditorSM() {
		myState = new PolicyEditorCS();
		currentHome = (PolicyEditorHome)(PortableRemoteObject.narrow(objectRef, PolicyEditorHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		PolicyEditor ref = (PolicyEditor) smr;
		try {
ref.setRequestorSessionRole(requestorSessionRole);
ref.setKnownRoles(knownRoles);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		PolicyEditor sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((PolicyEditorHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((PolicyEditorHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		PolicyEditor myActor = null;
		try {
			myActor = ((PolicyEditorHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		PolicyEditor ref = (PolicyEditor) smr;

requestorSessionRole = ref.getRequestorSessionRole();
knownRoles = ref.getKnownRoles();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
        System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    	System.out.println("Init'ing CBCCUserAgent");
    	System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    	knownRoles = new Hashtable();
        knownRoles.put("PolicyEditor.TerminalAgent", "TerminalPolicyEditor");
	}
	

	
} 