package no.ntnu.item.serviceframe.actors.policymanagement.policymanager;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import java.lang.String;
import no.ntnu.item.serviceframe.auxiliar.agentprofile.AgentProfile;
import no.ntnu.item.serviceframe.auxiliar.sessiondescription.SessionDescription;
import no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnGnotAReqMsg;
import java.util.ArrayList;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnRRReqMsg;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.PolicyConditionParser;
import no.ntnu.item.serviceframe.auxiliar.policyconditionparser.Node;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReplyMsg;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class PolicyManagerSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public java.lang.String currentSubjectRole;

public no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReplyMsg savedRoleBindingArrayListMsg;

public no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReplyMsg savedOnUnsRBPolicyListReplyMsg;

public java.util.ArrayList altRoleAndParameters;

public no.ntnu.item.serviceframe.auxiliar.policyconditionparser.Node roleBindingResult;

public no.ntnu.item.serviceframe.auxiliar.policyconditionparser.PolicyConditionParser policyConditionParser;

public no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnRRReqMsg savedPolicyCheckOnRRReqMsg;

public no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnGnotAReqMsg savedPolicyCheckOnGnotAReqMsg;

public no.ntnu.item.serviceframe.auxiliar.sessiondescription.SessionDescription currentSessionDescription;

public se.ericsson.eto.norarc.ejbframe.ActorAddress checkRequestor;

public no.ntnu.item.serviceframe.auxiliar.agentprofile.AgentProfile agentProfile;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public PolicyManagerSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("policymanager");
	//	myState = new PolicyManagerCS("PolicyManagerCS", null);
	//	currentHome = (PolicyManagerHome)(PortableRemoteObject.narrow(objectRef, PolicyManagerHome.class));
	//}

	public PolicyManagerSM() {
		myState = new PolicyManagerCS();
		currentHome = (PolicyManagerHome)(PortableRemoteObject.narrow(objectRef, PolicyManagerHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		PolicyManager ref = (PolicyManager) smr;
		try {
ref.setCurrentSubjectRole(currentSubjectRole);
ref.setSavedRoleBindingArrayListMsg(savedRoleBindingArrayListMsg);
ref.setSavedOnUnsRBPolicyListReplyMsg(savedOnUnsRBPolicyListReplyMsg);
ref.setAltRoleAndParameters(altRoleAndParameters);
ref.setRoleBindingResult(roleBindingResult);
ref.setPolicyConditionParser(policyConditionParser);
ref.setSavedPolicyCheckOnRRReqMsg(savedPolicyCheckOnRRReqMsg);
ref.setSavedPolicyCheckOnGnotAReqMsg(savedPolicyCheckOnGnotAReqMsg);
ref.setCurrentSessionDescription(currentSessionDescription);
ref.setCheckRequestor(checkRequestor);
ref.setAgentProfile(agentProfile);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		PolicyManager sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((PolicyManagerHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((PolicyManagerHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		PolicyManager myActor = null;
		try {
			myActor = ((PolicyManagerHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		PolicyManager ref = (PolicyManager) smr;

currentSubjectRole = ref.getCurrentSubjectRole();
savedRoleBindingArrayListMsg = ref.getSavedRoleBindingArrayListMsg();
savedOnUnsRBPolicyListReplyMsg = ref.getSavedOnUnsRBPolicyListReplyMsg();
altRoleAndParameters = ref.getAltRoleAndParameters();
roleBindingResult = ref.getRoleBindingResult();
policyConditionParser = ref.getPolicyConditionParser();
savedPolicyCheckOnRRReqMsg = ref.getSavedPolicyCheckOnRRReqMsg();
savedPolicyCheckOnGnotAReqMsg = ref.getSavedPolicyCheckOnGnotAReqMsg();
currentSessionDescription = ref.getCurrentSessionDescription();
checkRequestor = ref.getCheckRequestor();
agentProfile = ref.getAgentProfile();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	currentSubjectRole = null;
    	savedRoleBindingArrayListMsg = null;
    	savedOnUnsRBPolicyListReplyMsg = null;
    	policyConditionParser = new PolicyConditionParser(new java.io.StringReader(""));
	}
	

	
} 