package no.ntnu.item.serviceframe.actors.policymanagement.policystore;


import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;

import no.ntnu.item.serviceframe.auxiliar.policyobjects.OnUnsRoleBindingFSPolicyObject;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.PolicyObjectsStoringFacility;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyNOKMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.CollaborationPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.CollaborationPolicyListReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnNonAGPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnNonAGPolicyListReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnRRPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnRRPolicyListReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReqMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.CollaborationPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnNonAGPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnUnsRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.RoleBindingPolicyMsg;
import no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyNOKMsg;
import no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyOKMsg;
import no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyReqMsg;
public class PolicyStoreActions extends Object {



    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnRROk(OnRRPolicyMsg signal, PolicyStoreSM asm){
    	//ArrayList a = (ArrayList) asm.OnRoleRequestHashtable.get(signal.onrr.getSubject());
    	//if (a == null) a = new ArrayList();
    	//a.add(signal.onrr);
    	Hashtable p = (Hashtable) asm.OnRoleRequestHashtable.get(signal.onrr.getSubject());
    	if (p == null) p = new Hashtable();
    	p.put(signal.onrr.getPolicyID(), signal.onrr);
    	
   		asm.OnRoleRequestHashtable.put(signal.onrr.getSubject(), p);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnRoleRequest", asm.username, asm.OnRoleRequestHashtable);
    	System.out.println("*** Saving policies.."+asm.OnRoleRequestHashtable.size());
    	
   		ArrayList a = new ArrayList();
   		a.add(0, "OnRoleRequest");
   		a.add(1, signal.onrr.getSubject());
   		asm.allIDs.put(signal.onrr.getPolicyID(), a);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);
    	
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnNonAGOk(OnNonAGPolicyMsg signal, PolicyStoreSM asm){
    	Hashtable p = (Hashtable) asm.OnNonAGHashtable.get(signal.onnon.getSubject());
    	if (p == null) p = new Hashtable();
    	p.put(signal.onnon.getPolicyID(), signal.onnon);
   		asm.OnNonAGHashtable.put(signal.onnon.getSubject(), p);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnNonAchievedRoleGoal", asm.username, asm.OnNonAGHashtable);

   		ArrayList a = new ArrayList();
   		a.add(0, "OnNonAchievedRoleGoal");
   		a.add(1, signal.onnon.getSubject());
   		asm.allIDs.put(signal.onnon.getPolicyID(), a);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);

    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertRBOk(RoleBindingPolicyMsg signal, PolicyStoreSM asm){
    	Hashtable p = (Hashtable) asm.RoleBindingHashtable.get(signal.inv.getSubject());
    	if (p == null) p = new Hashtable();
    	p.put(signal.inv.getPolicyID(), signal.inv);
   		asm.RoleBindingHashtable.put(signal.inv.getSubject(), p);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("RoleBinding", asm.username, asm.RoleBindingHashtable);

   		ArrayList a = new ArrayList();
   		a.add(0, "RoleBinding");
   		a.add(1, signal.inv.getSubject());
   		asm.allIDs.put(signal.inv.getPolicyID(), a);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);

    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertCollaborationOk(CollaborationPolicyMsg signal, PolicyStoreSM asm){
    	Hashtable p = (Hashtable) asm.CollaborationHashtable.get(signal.runt.getSubject());
    	if (p == null) p = new Hashtable();
    	p.put(signal.runt.getPolicyID(), signal.runt);
   		asm.CollaborationHashtable.put(signal.runt.getSubject(), p);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("Collaboration", asm.username, asm.CollaborationHashtable);

   		ArrayList a = new ArrayList();
   		a.add(0, "Collaboration");
   		a.add(1, signal.runt.getSubject());
   		asm.allIDs.put(signal.runt.getPolicyID(), a);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);

    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnUnsRBOk(OnUnsRBPolicyMsg signal, PolicyStoreSM asm){
    	Hashtable p = (Hashtable) asm.OnUnsRBHashtable.get(signal.onuns.getSubject());
    	if (p == null) p = new Hashtable();
    	p.put(signal.onuns.getPolicyID(), signal.onuns);
   		asm.OnUnsRBHashtable.put(signal.onuns.getSubject(), p);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnUnsuccessfulRoleBinding", asm.username, asm.OnUnsRBHashtable);

   		ArrayList a = new ArrayList();
   		a.add(0, "OnUnsuccessfulRoleBinding");
   		a.add(1, signal.onuns.getSubject());
   		asm.allIDs.put(signal.onuns.getPolicyID(), a);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);

    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnRRArrayListReply(OnRRPolicyListReqMsg signal, PolicyStoreSM asm){
		System.out.println("**************** "+signal.role);
		
		if ((Hashtable)asm.OnRoleRequestHashtable.get(signal.role) == null)
			asm.sendMessage(new OnRRPolicyListReplyMsg(null, signal.role),
					signal.getSenderRole());
		else
			asm.sendMessage(new OnRRPolicyListReplyMsg(
				((Hashtable)asm.OnRoleRequestHashtable.get(signal.role)).values(), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnUnsRBArrayListReply(OnUnsRBPolicyListReqMsg signal, PolicyStoreSM asm){
		if ((Hashtable)asm.OnUnsRBHashtable.get(signal.role) == null)
			asm.sendMessage(new OnUnsRBPolicyListReplyMsg(null, signal.role),
					signal.getSenderRole());
		else
			asm.sendMessage(new OnUnsRBPolicyListReplyMsg(
				((Hashtable)asm.OnUnsRBHashtable.get(signal.role)).values(), signal.role),
				signal.getSenderRole());
    }

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnNonAGArrayListReply(OnNonAGPolicyListReqMsg signal, PolicyStoreSM asm){
		if ((Hashtable)asm.OnNonAGHashtable.get(signal.role) == null)
			asm.sendMessage(new OnNonAGPolicyListReplyMsg(null, signal.role),
					signal.getSenderRole());
		else
			asm.sendMessage(new OnNonAGPolicyListReplyMsg(
				((Hashtable)asm.OnNonAGHashtable.get(signal.role)).values(), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendCollaborationArrayListReply(CollaborationPolicyListReqMsg signal, PolicyStoreSM asm){
		if ((Hashtable)asm.CollaborationHashtable.get(signal.role) == null)
			asm.sendMessage(new CollaborationPolicyListReplyMsg(null, signal.role),
					signal.getSenderRole());
		else
			asm.sendMessage(new CollaborationPolicyListReplyMsg(
				((Hashtable)asm.CollaborationHashtable.get(signal.role)).values(), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendRoleBindingArrayListReply(RoleBindingPolicyListReqMsg signal, PolicyStoreSM asm){
		if ((Hashtable)asm.RoleBindingHashtable.get(signal.role) == null)
			asm.sendMessage(new RoleBindingPolicyListReplyMsg(null, signal.role),
					signal.getSenderRole());
		else
			asm.sendMessage(new RoleBindingPolicyListReplyMsg(
				((Hashtable)asm.RoleBindingHashtable.get(signal.role)).values(), signal.role),
				signal.getSenderRole());
    }


	public static void sendPolicies(GetPoliciesReqMsg signal, PolicyStoreSM asm){
		Collection list=null;
		if (signal.policyType.equalsIgnoreCase("RoleBinding") && (Hashtable)asm.RoleBindingHashtable.get(signal.subjectRole)!=null) {
			list = ((Hashtable)asm.RoleBindingHashtable.get(signal.subjectRole)).values();
		}
		else if (signal.policyType.equalsIgnoreCase("Collaboration") && (Hashtable)asm.CollaborationHashtable.get(signal.subjectRole)!=null) {
			list = ((Hashtable)asm.CollaborationHashtable.get(signal.subjectRole)).values(); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnRoleRequest") && (Hashtable)asm.OnRoleRequestHashtable.get(signal.subjectRole)!=null) {
			list = ((Hashtable)asm.OnRoleRequestHashtable.get(signal.subjectRole)).values(); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnUnsuccessfulRoleBinding") && (Hashtable)asm.OnUnsRBHashtable.get(signal.subjectRole)!=null) {
			list = ((Hashtable)asm.OnUnsRBHashtable.get(signal.subjectRole)).values(); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnNonAchievedRoleGoal") && (Hashtable)asm.OnNonAGHashtable.get(signal.subjectRole)!=null) {
			list = ((Hashtable)asm.OnNonAGHashtable.get(signal.subjectRole)).values(); 
		}
		asm.sendMessage(new GetPoliciesReplyMsg(signal.policyType, signal.subjectRole, list), signal.getSenderRole());
	}


	public static boolean policyIDOKForOnURB(OnUnsRBPolicyMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.onuns.getPolicyID()));
	}




	public static boolean policyIDNOKForOnURB(OnUnsRBPolicyMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.onuns.getPolicyID()));
	}


	public static void sendInsertOnUnsRBNOK(OnUnsRBPolicyMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new AddPolicyNOKMsg("PolicyID already exists"), signal.getSenderRole());
	}

    public static void sendInsertOnRRNOk(OnRRPolicyMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new AddPolicyNOKMsg("PolicyID already exists"), signal.getSenderRole());
	}
    public static void sendInsertOnNonAGNOk(OnNonAGPolicyMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new AddPolicyNOKMsg("PolicyID already exists"), signal.getSenderRole());
	}
    public static void sendInsertRBNOk(RoleBindingPolicyMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new AddPolicyNOKMsg("PolicyID already exists"), signal.getSenderRole());
	}
    public static void sendInsertCollaborationNOk(CollaborationPolicyMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new AddPolicyNOKMsg("PolicyID already exists"), signal.getSenderRole());
	}

	public static boolean policyIDNOKForOnRR(OnRRPolicyMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.onrr.getPolicyID()));
	}


	public static boolean policyIDOKForOnRR(OnRRPolicyMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.onrr.getPolicyID()));
	}


	public static boolean policyIDNOKForOnNonAG(OnNonAGPolicyMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.onnon.getPolicyID()));
	}


	public static boolean policyIDOKForOnNonAG(OnNonAGPolicyMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.onnon.getPolicyID()));
	}


	public static boolean policyIDNOKForRB(RoleBindingPolicyMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.inv.getPolicyID()));
	}


	public static boolean policyIDOKForRB(RoleBindingPolicyMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.inv.getPolicyID()));
	}


	public static boolean policyIDNOKForCollab(CollaborationPolicyMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.runt.getPolicyID()));
	}


	public static boolean policyIDOKForCollab(CollaborationPolicyMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.runt.getPolicyID()));
	}


	public static void processDeletePolicyReq(DeletePolicyReqMsg signal, PolicyStoreSM asm){
	    // TODO edit action statements
	}


	public static void sendDeletePolicyNOK(DeletePolicyReqMsg signal, PolicyStoreSM asm){
    	asm.sendMessage(new DeletePolicyNOKMsg("PolicyID does not exist"), signal.getSenderRole());
	}


	public static boolean deletePolicyReqNOK(DeletePolicyReqMsg signal, PolicyStoreSM asm){
		return !(asm.allIDs.containsKey(signal.policyID));
	}


	public static void sendDeletePolicyOK(DeletePolicyReqMsg signal, PolicyStoreSM asm){
   		ArrayList a = (ArrayList)asm.allIDs.get(signal.policyID);
		
   		if (((String)a.get(0)).equalsIgnoreCase("RoleBinding")) {
  	   			((Hashtable)asm.RoleBindingHashtable.get(a.get(1))).remove(signal.policyID);
   	   			PolicyObjectsStoringFacility.savePolicyObjectsToDisk("RoleBinding", asm.username, asm.RoleBindingHashtable);
		}
		else if (((String)a.get(0)).equalsIgnoreCase("Collaboration")) {
   			((Hashtable)asm.CollaborationHashtable.get(a.get(1))).remove(signal.policyID);
   			PolicyObjectsStoringFacility.savePolicyObjectsToDisk("Collaboration", asm.username, asm.CollaborationHashtable);
		}
		else if (((String)a.get(0)).equalsIgnoreCase("OnRoleRequest")) {
	   			((Hashtable)asm.OnRoleRequestHashtable.get(a.get(1))).remove(signal.policyID);
	   			PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnRoleRequest", asm.username, asm.OnRoleRequestHashtable);
		}
		else if (((String)a.get(0)).equalsIgnoreCase("OnUnsuccessfulRoleBinding")) {
   			((Hashtable)asm.OnUnsRBHashtable.get(a.get(1))).remove(signal.policyID);
   			PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnUnsuccessfulRoleBinding", asm.username, asm.OnUnsRBHashtable);
		}
		else if (((String)a.get(0)).equalsIgnoreCase("OnNonAchievedRoleGoal")) {
   			((Hashtable)asm.OnNonAGHashtable.get(a.get(1))).remove(signal.policyID);
   			PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnNonAchievedRoleGoal", asm.username, asm.OnNonAGHashtable);
		}
		
   		asm.allIDs.remove(signal.policyID);
    	PolicyObjectsStoringFacility.savePolicyIDsToDisk(asm.allIDs, asm.username);
		
    	asm.sendMessage(new DeletePolicyOKMsg(), signal.getSenderRole());
	}


	public static boolean deletePolicyOK(DeletePolicyReqMsg signal, PolicyStoreSM asm){
		return (asm.allIDs.containsKey(signal.policyID));
	}

}
