package no.ntnu.item.serviceframe.actors.policymanagement.policystore;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import java.lang.String;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import java.util.Hashtable;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.PolicyObjectsStoringFacility;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class PolicyStoreSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public java.util.Hashtable OnRoleRequestHashtable;

public java.util.Hashtable OnNonAGHashtable;

public java.util.Hashtable OnUnsRBHashtable;

public java.util.Hashtable RoleBindingHashtable;

public java.util.Hashtable CollaborationHashtable;

public java.lang.String username;

public java.util.Hashtable allIDs;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public PolicyStoreSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("policystore");
	//	myState = new PolicyStoreCS("PolicyStoreCS", null);
	//	currentHome = (PolicyStoreHome)(PortableRemoteObject.narrow(objectRef, PolicyStoreHome.class));
	//}

	public PolicyStoreSM() {
		myState = new PolicyStoreCS();
		currentHome = (PolicyStoreHome)(PortableRemoteObject.narrow(objectRef, PolicyStoreHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		PolicyStore ref = (PolicyStore) smr;
		try {
ref.setOnRoleRequestHashtable(OnRoleRequestHashtable);
ref.setOnNonAGHashtable(OnNonAGHashtable);
ref.setOnUnsRBHashtable(OnUnsRBHashtable);
ref.setRoleBindingHashtable(RoleBindingHashtable);
ref.setCollaborationHashtable(CollaborationHashtable);
ref.setUsername(username);
ref.setAllIDs(allIDs);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		PolicyStore sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((PolicyStoreHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((PolicyStoreHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		PolicyStore myActor = null;
		try {
			myActor = ((PolicyStoreHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		PolicyStore ref = (PolicyStore) smr;

OnRoleRequestHashtable = ref.getOnRoleRequestHashtable();
OnNonAGHashtable = ref.getOnNonAGHashtable();
OnUnsRBHashtable = ref.getOnUnsRBHashtable();
RoleBindingHashtable = ref.getRoleBindingHashtable();
CollaborationHashtable = ref.getCollaborationHashtable();
username = ref.getUsername();
allIDs = ref.getAllIDs();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	/*******************************************************
         * - "allIds" is a Hashtable where:
         * 		- Keys are 'policyIDs'
         * 		- Values are ArrayLists of two elements with the following 
         * 			format: (<<policyType>>, <<subjectRole>>)
         * 			E.g. ("RoleBinding", "EnhancedChatServer")
         * 
         * 
         * - OnRoleRequestHashtable, OnNonAGHashtable, OnUnsRBHashtable,
         * RoleBindingHashtable and CollaborationHashtable are Hastables 
         * containing policy objects. Their format is:
         * 		- Keys are 'subjectRoles'
         * 		- Values are , in turn, Hashtables with 'policyIDs" as keys
         * 			and policy objects as values
         * 				
         * 			     
         *******************************************************/
    	
    	this.username = this.context.getParentAddress().getActorID().substring(this.context.getParentAddress().getActorID().lastIndexOf('/') + 1);
    	
    	allIDs = PolicyObjectsStoringFacility.readPolicyIDsFromDisk(username);
        if (allIDs == null) {
        	allIDs = new Hashtable();
        	PolicyObjectsStoringFacility.savePolicyIDsToDisk(allIDs, username);
        }
        
        
        System.out.println("****"+username);
        OnRoleRequestHashtable = PolicyObjectsStoringFacility.readPolicyObjectsFromDisk("OnRoleRequest", username);
        
        if (OnRoleRequestHashtable==null) {
    		System.out.println("**** Policy file is empty");
    		OnRoleRequestHashtable = new Hashtable();
    		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnRoleRequest", username, OnRoleRequestHashtable);
    		System.out.println("*** Saving policies.."+OnRoleRequestHashtable.size());
    	}

    	OnNonAGHashtable = PolicyObjectsStoringFacility.readPolicyObjectsFromDisk("OnNonAchievedRoleGoal", username);
    	if (OnNonAGHashtable==null) {
    		OnNonAGHashtable = new Hashtable();
       		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnNonAchievedRoleGoal", username, OnNonAGHashtable);
    	}

    	OnUnsRBHashtable = PolicyObjectsStoringFacility.readPolicyObjectsFromDisk("OnUnsuccessfulRoleBinding", username);
    	if (OnUnsRBHashtable==null) {
    		OnUnsRBHashtable = new Hashtable();
       		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnUnsuccessfulRoleBinding", username, OnUnsRBHashtable);
    	}

    	RoleBindingHashtable = PolicyObjectsStoringFacility.readPolicyObjectsFromDisk("RoleBinding", username);
    	if (RoleBindingHashtable==null) {
    		RoleBindingHashtable = new Hashtable();
       		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("RoleBinding", username, RoleBindingHashtable);
    	}

    	CollaborationHashtable = PolicyObjectsStoringFacility.readPolicyObjectsFromDisk("Collaboration", username);
    	if (CollaborationHashtable==null) {
    		CollaborationHashtable = new Hashtable();
       		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("Collaboration", username, CollaborationHashtable);
    	}
	}
	

	
} 