package no.ntnu.item.serviceframe.actors.profileeditor.profileeditor;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import java.util.ArrayList;
import no.ntnu.item.serviceframe.auxiliar.agentprofile.AgentProfile;
import no.ntnu.item.serviceframe.auxiliar.agentprofile.MalabarMPProfile;
import no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class ProfileEditorSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public java.util.ArrayList subscribedActors;

public no.ntnu.item.serviceframe.auxiliar.agentprofile.AgentProfile profile;

public java.lang.String profileID;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public ProfileEditorSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("profileeditor");
	//	myState = new ProfileEditorCS("ProfileEditorCS", null);
	//	currentHome = (ProfileEditorHome)(PortableRemoteObject.narrow(objectRef, ProfileEditorHome.class));
	//}

	public ProfileEditorSM() {
		myState = new ProfileEditorCS();
		currentHome = (ProfileEditorHome)(PortableRemoteObject.narrow(objectRef, ProfileEditorHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		ProfileEditor ref = (ProfileEditor) smr;
		try {
ref.setSubscribedActors(subscribedActors);
ref.setProfile(profile);
ref.setProfileID(profileID);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		ProfileEditor sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((ProfileEditorHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((ProfileEditorHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		ProfileEditor myActor = null;
		try {
			myActor = ((ProfileEditorHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		ProfileEditor ref = (ProfileEditor) smr;

subscribedActors = ref.getSubscribedActors();
profile = ref.getProfile();
profileID = ref.getProfileID();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	subscribedActors = new ArrayList();
    	profileID = this.context.getParentAddress().getActorID().substring(this.context.getParentAddress().getActorID().lastIndexOf('/') + 1);
    	//We assume that a profile with the right <profileID> already
    	//exists on the disk
    	//There should be implemented some mechanism to create a profile 
    	profile = profile.readFromDisk(profileID);
    	if (profile==null) {
    		if (this.context.getParentAddress().getActorType().endsWith("UserAgent"))
    		{
    			profile=new UserProfile();
    			((UserProfile)profile).setUserName(profileID);
    			((UserProfile)profile).setPassword("");
    			profile.saveToDisk(profileID);
    		}
    		else if (this.context.getParentAddress().getActorType().endsWith("MalabarMPAgent"))
    			profile=new MalabarMPProfile();
    		else
    			profile=new AgentProfile();

    	}
	}
	

	
} 