package no.ntnu.item.serviceframe.actors.terminalagent.terminalclientsession;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg;
import java.lang.String;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import java.util.Hashtable;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class TerminalClientSessionSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public se.ericsson.eto.norarc.ejbframe.ActorAddress myTerminal;

public java.lang.String username;

public java.lang.String password;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg savedServiceSessionReqMsg;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg savedServiceSessionConfMsg;

public java.lang.String userterminalsessionid;

public se.ericsson.eto.norarc.ejbframe.ActorAddress userterminalsessionAddress;

public java.util.Hashtable knownRoles;

public java.lang.String roleToPlay;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public TerminalClientSessionSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("terminalclientsession");
	//	myState = new TerminalClientSessionCS("TerminalClientSessionCS", null);
	//	currentHome = (TerminalClientSessionHome)(PortableRemoteObject.narrow(objectRef, TerminalClientSessionHome.class));
	//}

	public TerminalClientSessionSM() {
		myState = new TerminalClientSessionCS();
		currentHome = (TerminalClientSessionHome)(PortableRemoteObject.narrow(objectRef, TerminalClientSessionHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		TerminalClientSession ref = (TerminalClientSession) smr;
		try {
ref.setMyTerminal(myTerminal);
ref.setUsername(username);
ref.setPassword(password);
ref.setSavedServiceSessionReqMsg(savedServiceSessionReqMsg);
ref.setSavedServiceSessionConfMsg(savedServiceSessionConfMsg);
ref.setUserterminalsessionid(userterminalsessionid);
ref.setUserterminalsessionAddress(userterminalsessionAddress);
ref.setKnownRoles(knownRoles);
ref.setRoleToPlay(roleToPlay);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		TerminalClientSession sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((TerminalClientSessionHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((TerminalClientSessionHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		TerminalClientSession myActor = null;
		try {
			myActor = ((TerminalClientSessionHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		TerminalClientSession ref = (TerminalClientSession) smr;

myTerminal = ref.getMyTerminal();
username = ref.getUsername();
password = ref.getPassword();
savedServiceSessionReqMsg = ref.getSavedServiceSessionReqMsg();
savedServiceSessionConfMsg = ref.getSavedServiceSessionConfMsg();
userterminalsessionid = ref.getUserterminalsessionid();
userterminalsessionAddress = ref.getUserterminalsessionAddress();
knownRoles = ref.getKnownRoles();
roleToPlay = ref.getRoleToPlay();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	
	}
	

	
} 