package no.ntnu.item.serviceframe.actors.useragent.userterminalsession;


public class UserTerminalSessionCS extends se.ericsson.eto.norarc.ejbactorframe.ActorCS {


    protected se.ericsson.eto.norarc.ejbframe.State authenticated = new se.ericsson.eto.norarc.ejbframe.State("authenticated", this);
    protected se.ericsson.eto.norarc.ejbframe.State waitPolicyCheckResult = new se.ericsson.eto.norarc.ejbframe.State("waitPolicyCheckResult", this);
    protected se.ericsson.eto.norarc.ejbframe.State waitServiceRoleConfirm = new se.ericsson.eto.norarc.ejbframe.State("waitServiceRoleConfirm", this);
    protected se.ericsson.eto.norarc.ejbframe.State waitSessionRoleConfirm = new se.ericsson.eto.norarc.ejbframe.State("waitSessionRoleConfirm", this);
    protected se.ericsson.eto.norarc.ejbframe.State waitForUserProfile = new se.ericsson.eto.norarc.ejbframe.State("waitForUserProfile", this);
    protected se.ericsson.eto.norarc.ejbframe.State waitLookupServicesResult = new se.ericsson.eto.norarc.ejbframe.State("waitLookupServicesResult", this);

    public UserTerminalSessionCS() {
        super();
    }


    public void execTrans(se.ericsson.eto.norarc.ejbframe.messages.ActorMsg signal, se.ericsson.eto.norarc.ejbframe.State state, se.ericsson.eto.norarc.ejbframe.StateMachine curfsm){
        super.execTrans(signal, state, curfsm);
        no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionSM asm = (no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionSM) curfsm;
        if(state == idle) {
            if(signal instanceof no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationReq) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.requestUserProfile((no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationReq) signal, asm);
                performExit(curfsm);
                nextState(waitForUserProfile, curfsm);
            }
        } else if(state == authenticated) {
            if(signal instanceof no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg) {
                if(UserTerminalSessionActions.serviceRoleKnown((no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg) signal, asm)) {
                    no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendPolicyCheckRequest((no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg) signal, asm);
                    performExit(curfsm);
                    nextState(waitPolicyCheckResult, curfsm);
                } else if(UserTerminalSessionActions.serviceRoleUnknown((no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg) signal, asm)) {
                    no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendSSDonRoleUnknown((no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg) signal, asm);
                    performExit(curfsm);
                    nextState(authenticated, curfsm);
                }
            } else if(signal instanceof no.ntnu.item.serviceframe.signals.handshake.HelloMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.lookupForAvailableServices((no.ntnu.item.serviceframe.signals.handshake.HelloMsg) signal, asm);
                performExit(curfsm);
                nextState(waitLookupServicesResult, curfsm);
            } else if(signal instanceof no.ntnu.item.serviceframe.signals.policycheck.GoalNotAchievedMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.requestPolicyCheckOnNAG((no.ntnu.item.serviceframe.signals.policycheck.GoalNotAchievedMsg) signal, asm);
                performExit(curfsm);
                nextState(waitPolicyCheckResult, curfsm);
            }
        } else if(state == waitPolicyCheckResult) {
            if(signal instanceof no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckNOKMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendSSD((no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckNOKMsg) signal, asm);
                performExit(curfsm);
                nextState(authenticated, curfsm);
            } else if(signal instanceof no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOKMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.createRequestedServiceRole((no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOKMsg) signal, asm);
                performExit(curfsm);
                nextState(waitServiceRoleConfirm, curfsm);
            }
        } else if(state == waitServiceRoleConfirm) {
            if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.RoleConfirmMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.createRequestedServiceSessionRole((se.ericsson.eto.norarc.ejbactorframe.messages.RoleConfirmMsg) signal, asm);
                performExit(curfsm);
                nextState(waitSessionRoleConfirm, curfsm);
            }
        } else if(state == waitSessionRoleConfirm) {
            if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.RoleConfirmMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendSSC1((se.ericsson.eto.norarc.ejbactorframe.messages.RoleConfirmMsg) signal, asm);
                performExit(curfsm);
                nextState(authenticated, curfsm);
            } else if(signal instanceof se.ericsson.eto.norarc.ejbactorframe.messages.RoleDeniedMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendSSC2((se.ericsson.eto.norarc.ejbactorframe.messages.RoleDeniedMsg) signal, asm);
                performExit(curfsm);
                nextState(authenticated, curfsm);
            }
        } else if(state == waitForUserProfile) {
            if(signal instanceof no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.saveUserProfile((no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) signal, asm);
                if(UserTerminalSessionActions.authReqValid((no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) signal, asm)) {
                    no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendAuthValid((no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) signal, asm);
                    performExit(curfsm);
                    nextState(authenticated, curfsm);
                } else if(UserTerminalSessionActions.authReqNotValid((no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) signal, asm)) {
                    no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendAuthNotValid((no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg) signal, asm);
                    performExit(curfsm);
                    nextState(idle, curfsm);
                }
            }
        } else if(state == waitLookupServicesResult) {
            if(signal instanceof no.ntnu.item.serviceframe.signals.serviceregistry.LookupServicesResultMsg) {
                no.ntnu.item.serviceframe.actors.useragent.userterminalsession.UserTerminalSessionActions.sendBackHelloHello((no.ntnu.item.serviceframe.signals.serviceregistry.LookupServicesResultMsg) signal, asm);
                performExit(curfsm);
                nextState(authenticated, curfsm);
            }
        }
    }
}
