package no.ntnu.item.serviceframe.actors.useragent.userterminalsession;

import java.rmi.RemoteException;
import java.util.Collection;

// Hello

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;
import javax.rmi.PortableRemoteObject;

import se.ericsson.eto.norarc.ejbactorframe.PartSpec;
import se.ericsson.eto.norarc.ejbframe.StateData;


import java.lang.String;
import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg;
import se.ericsson.eto.norarc.ejbactorframe.ActorSM;
import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg;
import no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationReq;
import java.util.Hashtable;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must also have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class UserTerminalSessionSM extends se.ericsson.eto.norarc.ejbactorframe.ActorSM {



public se.ericsson.eto.norarc.ejbframe.ActorAddress terminalClientSessionRef;

public se.ericsson.eto.norarc.ejbframe.ActorAddress serviceRoleRequestor;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg savedServiceSessionReqMsg;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg savedServiceSessionConfMsg;

public java.util.Hashtable knownRoles;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg savedRemoteServiceSessionReqMsg;

public no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg savedRemoteServiceSessionConfMsg;

public no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationReq savedAuthReq;

public no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile userProfile;

public java.util.Hashtable sessionDescriptions;

public java.lang.String roleIntendedToBePlayed;


	/**
	 * Constructor creates the outermost composite state, reads the actor type that this
	 * state machine implements and finds the reference to the entity bean that represents
	 * the data for this state machine. The JNDI name for the entity bean should be equal
	 * to the actor type.
	 */
	//public UserTerminalSessionSM() {
		/*
		 * It is VERY important that the the String parameter in the call to super is lower
		 * case. This is because it must match the queue name, this message driven bean will
		 * listen to. The same name must be defined in jboss.xml, look for comments in that
		 * file, and a queue must be created with the same name.
		 */
	//	super("userterminalsession");
	//	myState = new UserTerminalSessionCS("UserTerminalSessionCS", null);
	//	currentHome = (UserTerminalSessionHome)(PortableRemoteObject.narrow(objectRef, UserTerminalSessionHome.class));
	//}

	public UserTerminalSessionSM() {
		myState = new UserTerminalSessionCS();
		currentHome = (UserTerminalSessionHome)(PortableRemoteObject.narrow(objectRef, UserTerminalSessionHome.class));
	}
	/**
	 * Store the state data. Not used by the application
	 */
	protected void storeData(StateData smr) {
		super.storeData(smr);
		UserTerminalSession ref = (UserTerminalSession) smr;
		try {
ref.setTerminalClientSessionRef(terminalClientSessionRef);
ref.setServiceRoleRequestor(serviceRoleRequestor);
ref.setSavedServiceSessionReqMsg(savedServiceSessionReqMsg);
ref.setSavedServiceSessionConfMsg(savedServiceSessionConfMsg);
ref.setKnownRoles(knownRoles);
ref.setSavedRemoteServiceSessionReqMsg(savedRemoteServiceSessionReqMsg);
ref.setSavedRemoteServiceSessionConfMsg(savedRemoteServiceSessionConfMsg);
ref.setSavedAuthReq(savedAuthReq);
ref.setUserProfile(userProfile);
ref.setSessionDescriptions(sessionDescriptions);
ref.setRoleIntendedToBePlayed(roleIntendedToBePlayed);
		} catch (RemoteException e) {e.printStackTrace();}
	}

	/**
	 * Create a new instance. Not used by the application
	 */
	protected void createInstance(EJBHome home, String myId)
		throws RemoteException {
		UserTerminalSession sm = null;
		try {
			currentStateId = initialState.stateName();
			// initial state contains the initial State set at creation
			sm = ((UserTerminalSessionHome) home).create(myId, currentStateId);
			currentObject = sm;
			//Do not change myActorType in the following string!!!
			trace.traceSystem(
				"INSTANCE CREATED: " + myId + "@" + myActorType + " TIME: ?");
			//Do not change myActorType in the latter string!!!	
		} catch (CreateException e1) {
			java.lang.System.out.println(
				"Error when new instance created myId: "
					+ myId
					+ "  - "
					+ e1.toString());

		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Find all instances of this actor type.
     * @param home The interface that identifies the actors
     * @return The set of actors found
	 */
	protected Collection findAllInstances(EJBHome home)
		throws RemoteException {
		Collection col = null;
		try {
			col = ((UserTerminalSessionHome) currentHome).findAll();
		} catch (FinderException e) {
			e.printStackTrace();

		}
		return col;
	}

	/**
	 * Find a specific instances of this actor type.
     * @param home The interface that identifies the actors
     * @param myId The actor identifier
     * @return The found actor
	 */
	protected StateData findEntityBean(EJBHome home, String myId)
		throws RemoteException {
		UserTerminalSession myActor = null;
		try {
			myActor = ((UserTerminalSessionHome) home).findByPrimaryKey(myId);
		} catch (FinderException e) {
			myActor = null;
			e.printStackTrace();
		}
		return myActor;
	}

	/**
	 * Load application specific actor persisten attributes.
     * Not used by the application
	 */
	protected void getData(StateData smr) throws RemoteException {
		super.getData(smr);
		UserTerminalSession ref = (UserTerminalSession) smr;

terminalClientSessionRef = ref.getTerminalClientSessionRef();
serviceRoleRequestor = ref.getServiceRoleRequestor();
savedServiceSessionReqMsg = ref.getSavedServiceSessionReqMsg();
savedServiceSessionConfMsg = ref.getSavedServiceSessionConfMsg();
knownRoles = ref.getKnownRoles();
savedRemoteServiceSessionReqMsg = ref.getSavedRemoteServiceSessionReqMsg();
savedRemoteServiceSessionConfMsg = ref.getSavedRemoteServiceSessionConfMsg();
savedAuthReq = ref.getSavedAuthReq();
userProfile = ref.getUserProfile();
sessionDescriptions = ref.getSessionDescriptions();
roleIntendedToBePlayed = ref.getRoleIntendedToBePlayed();							

	}
	
    /**
     * Initiation of the actor state machine.
     * Not used by the application, but actor specific initiation may be done here.
     */
    protected void initStateMachine() {
        super.initStateMachine();
       //Add part spec if XML file is not used 
    }

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has mot yet been created.
     */
    protected void initInstance() {
        super.initInstance();
    	/*        serviceList = new ArrayList();        
        serviceList.add(new ServiceDescription("MalabarMP",
        		"<html>" +
        		"<body>" +
        		"<h1>Malabar Meeting Place</h1>" +
        		"<p>The Malabar Meeting Place is a collection of meetingplaces for students and employees of NTNU.</p>" +
        		"<p><b>Instructions:</b> Click MalabarMP and then Connect to request this service.</p>" +
        		"</body>" +
        		"</html>"));
        serviceList.add(new ServiceDescription("NTNUMPs",
        		"<html>" +
        		"<body>" +
        		"<h1>NTNU Meeting-Places</h1>" +
        		"<p>NTNU Meeting-Places is a collection of meetingplaces for students and employees of NTNU.</p>" +
        		"<p><b>Instructions:</b> Click NTNUMP and then Connect to request this service.</p>" +
        		"</body>" +
        		"</html>"));
        serviceList.add(new ServiceDescription("IM",
        		"<html>" +
        		"<body>" +
        		"<h1>Instant Messaging</h1>" +
        		"<p>The instant messaging service lets you connect directly to your friends.</p>" +
        		"<p><b>Instructions:</b> Click IM and then Connect to request this service.</p>" +
        		"</body>" +
        		"</html>"));
        
        serviceList.add(new no.ntnu.item.serviceframe.auxiliar.servicedescription.ServiceDescription("PolicyEditor",
        		"<html>" +
        		"<body>" +
        		"<h1>PolicyEditor</h1>" +
        		"<p>The PolicyEditor service allows to add and remove policies from the PolicyStore.</p>" +
        		"<p><b>Instructions:</b> Click on Connect to request this service.</p>" +
        		"</body>" +
        		"</html>"));
*/        
        knownRoles = new Hashtable();
        //knownRoles.put("PolicyEditor.UserAgent", "PolicyEditor");

        
        //knownRoles.put("MalabarMP.UserAgent", "UserMalabarMP");
        //knownRoles.put("MalabarMP.TerminalAgent", "TerminalMalabarMP");
        //knownRoles.put("PolicyEditor.TerminalAgent", "TerminalPolicyEditor");

        /*      knownRoles.put("NTNUMPs.UserAgent", "UserNTNUMPs");
        knownRoles.put("NTNUMPs.TerminalAgent", "TerminalNTNUMPs");
        knownRoles.put("IM.UserAgent", "UserIM");
*/      


        //initialize temporary variables        
        serviceRoleRequestor = null;
        savedServiceSessionReqMsg = null;
        savedServiceSessionConfMsg = null;         
        terminalClientSessionRef = null;
        savedRemoteServiceSessionReqMsg = null;
        savedRemoteServiceSessionConfMsg = null;
        sessionDescriptions = new Hashtable();
	}
	

	
} 