package no.ntnu.item.serviceframe.auxiliar.policyconditionparser;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.PropertyResourceBundle;

import no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;

public class DummyClass {

	PolicyConditionParser myConditionParser;
	PropertyResourceBundle myPolicyProperties;
	
	public void doTest () {
		//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    	//System.out.println("doTest()");
    	//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		this.myConditionParser = new PolicyConditionParser(new java.io.StringReader(""));
		try {
			this.myPolicyProperties = new PropertyResourceBundle(
					new FileInputStream(new File("policies.properties")));
			int numberOfPolicies = new Integer(this.myPolicyProperties
					.getString("numberOfPolicies")).intValue();
			// register all the activities
			String policyType = "OnRoleRequest";
			for (int i = 1; i <= numberOfPolicies; i++) {
				String policySubjectRole = this.myPolicyProperties.getString(i
						+ "subjectRole");
				String policyDeducedActivity = this.myPolicyProperties
						.getString(i + "deducedActivity");
				String policyHomeAvailability = this.myPolicyProperties
						.getString(i + "homeAvailability");
				String policyOfficeAvailability = this.myPolicyProperties
						.getString(i + "officeAvailability");
				String policyMeetingRoomAvailability = this.myPolicyProperties
						.getString(i + "meetingRoomAvailability");
				String policyCallType = this.myPolicyProperties.getString(i
						+ "callType");
				String policyAlternativeRole = this.myPolicyProperties
						.getString(i + "alternativeRole");
				String policyID = i + "";
				Hashtable parameters = new Hashtable();
				String conditionText = "";
				String parametersText = "";
				// ("DEDUCED_ACTIVITY(working) AND AVAILABILITY.user(home,low)
				// AND AVAILABILITY.user(office,low) AND
				// AVAILABILITY.user(meeting-room,low)
				// AND CALLTYPE(family)\n");
				Node condition;
				String conditionString = "DEDUCED_ACTIVITY("
						+ policyDeducedActivity
						+ ") AND AVAILABILITY.user(home,"
						+ policyHomeAvailability
						+ ") AND AVAILABILITY.user(office,"
						+ policyOfficeAvailability
						+ ") AND AVAILABILITY.user(meeting-room,"
						+ policyMeetingRoomAvailability + ") AND CALLTYPE("
						+ policyCallType + ")\n";
				//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		    	System.out.println("The condition is: " + conditionString);
		    	//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		    	System.out.println("DEDUCED_ACTIVITY(working) AND AVAILABILITY.user(home,low) AND AVAILABILITY.user(office,low) AND AVAILABILITY.user(meeting-room,low) AND CALLTYPE(family)\n");
				try {
					condition = this.myConditionParser
							.parseCondition(conditionString);
					AddOnRRPolicyMsg msg = new AddOnRRPolicyMsg(policyID,
							policySubjectRole, policyType, condition,
							policyAlternativeRole, parameters, conditionText,
							parametersText);
					//this.sendMessage(msg, this.myPolicyEditor);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} // end for
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		
    	DummyClass d = new DummyClass();
    	//d.doTest();
		
		
		
		
		PolicyConditionParser p = new PolicyConditionParser(new java.io.StringReader(""));
		try {
			Node cond = p.parseCondition("" +
"DEDUCED_ACTIVITY(working) AND CALLTYPE(family) AND AVAILABILITY.user(o_high, h_medium, m_low, r_high)\n");
			System.out.println("1OK");
		} catch (ParseException e) {
			System.out.println("1ERROR in Condition field: "+e.getMessage());
			//e.printStackTrace();
			
		}
		/*try {
			Node cond = p.parseCondition("AVAILABILITY.user(office,low) AND CALLTYPE(family)\n");
			System.out.println("2OK");
		} catch (ParseException e) {
			System.out.println("2ERROR in Condition field: "+e.getMessage());
			//e.printStackTrace();
			
		}
		try {
			Node cond = p.parseCondition("AVAILABILITY.user(meeting-room,medium) AND CALLTYPE(work)\n");
			System.out.println("3OK");
		} catch (ParseException e) {
			System.out.println("3ERROR in Condition field: "+e.getMessage());
			//e.printStackTrace();
			
		}
		try {
			Node cond = p.parseCondition("AVAILABILITY.user(restaurant,high) AND CALLTYPE(work)\n");
			System.out.println("4OK");
		} catch (ParseException e) {
			System.out.println("4ERROR in Condition field: "+e.getMessage());
			//e.printStackTrace();
			
		}*/

	}

}
