package no.ntnu.item.serviceframe.auxiliar.policyobjects;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import no.ntnu.item.serviceframe.auxiliar.agentprofile.UserProfile;


public class PolicyObjectsStoringFacility {
	
		
	public static boolean savePolicyObjectsToDisk(String policyType, String username, Hashtable policies) {

		// Use a FileOutputStream to send data to a file
		// called <policyType>Policies_<username>.data
		FileOutputStream f_out;
		try {
			f_out = new FileOutputStream(policyType+ "Policies_"+ username+ ".data");
		} catch (FileNotFoundException e) {
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		
		// Use an ObjectOutputStream to send object data to the
		// FileOutputStream for writing to disk.
		ObjectOutputStream obj_out = null;
		try {
			obj_out = new ObjectOutputStream(f_out);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught when creating ObjectOutputStream >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		
		// Pass our object to the ObjectOutputStream's
		// writeObject() method to cause it to be written out
		// to disk.
		try {
			obj_out.writeObject(policies);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught when writing object >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		return true;
	}

	public static Hashtable readPolicyObjectsFromDisk(String policyType, String username) {

		// Read from disk using FileInputStream.
		FileInputStream f_in;
		try {
			f_in = new FileInputStream(policyType+ "Policies_"+ username+ ".data");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
		
		// Read object using ObjectInputStream.
		ObjectInputStream obj_in;
		try {
			obj_in = new ObjectInputStream(f_in);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught when creating ObjectInputStream  >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
		
		// Read an object.
		try {
			return (Hashtable)obj_in.readObject();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught when reading object >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught (ClassNotFoundException) >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
	}

	public static boolean savePolicyIDsToDisk(Hashtable policyIDs, String username) {

		// Use a FileOutputStream to send data to a file
		// called PolicyIDs_<username>.data
		FileOutputStream f_out;
		try {
			f_out = new FileOutputStream("PolicyIDs_"+ username+ ".data");
		} catch (FileNotFoundException e) {
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		
		// Use an ObjectOutputStream to send object data to the
		// FileOutputStream for writing to disk.
		ObjectOutputStream obj_out = null;
		try {
			obj_out = new ObjectOutputStream(f_out);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		
		// Pass our object to the ObjectOutputStream's
		// writeObject() method to cause it to be written out
		// to disk.
		try {
			obj_out.writeObject(policyIDs);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return false;
		}
		return true;
	}

	public static Hashtable readPolicyIDsFromDisk(String username) {

		// Read from disk using FileInputStream.
		FileInputStream f_in;
		try {
			f_in = new FileInputStream("PolicyIDs_"+ username+ ".data");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
		
		// Read object using ObjectInputStream.
		ObjectInputStream obj_in;
		try {
			obj_in = new ObjectInputStream(f_in);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
		
		// Read an object.
		try {
			return (Hashtable)obj_in.readObject();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
			System.out.println(e.getMessage());
			//e.printStackTrace();
			System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
			return null;
		}
	}
	
}
