package simulation;

import no.ntnu.item.serviceframe.actors.serviceregistry.serviceregistry.sim.SimServiceRegistrySM;
import no.ntnu.item.contextengine.sensors.locationsensor.locationsensor.sim.SimLocationSensorSM;
import no.ntnu.item.serviceframe.actors.terminalagent.terminalagent.sim.SimTerminalAgentSM;
import no.ntnu.item.serviceframe.actors.policymanagement.policystore.sim.SimPolicyStoreSM;
import no.ntnu.item.mam.actors.ccnrgedgeactors.nrgcallcontrolfeature.sim.SimNRGCallControlFeatureSM;
import no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.nrglocationfeature.sim.SimNRGLocationFeatureSM;
import no.ntnu.item.serviceframe.actors.policymanagement.terminalpolicyeditor.sim.SimTerminalPolicyEditorSM;
import no.ntnu.item.serviceframe.actors.profileeditor.profileeditor.sim.SimProfileEditorSM;
import no.ntnu.item.serviceframe.actors.policymanagement.policymanager.sim.SimPolicyManagerSM;
import no.ntnu.item.serviceframe.actors.policymanagement.policyeditor.sim.SimPolicyEditorSM;
import no.ntnu.item.cbcc.cbccuseragent.cbccuseragent.sim.SimCBCCUserAgentSM;
import no.ntnu.item.serviceframe.actors.useragent.userterminalsession.sim.SimUserTerminalSessionSM;
import no.ntnu.item.serviceframe.actors.useragent.useragent.sim.SimUserAgentSM;
import no.ntnu.item.contextengine.contextengine.sim.SimContextEngineSM;
import no.ntnu.item.cbcc.cbccuseragent.callcontroller.sim.SimCallControllerSM;
import no.ntnu.item.serviceframe.actors.terminalagent.terminalclientsession.sim.SimTerminalClientSessionSM;
import se.ericsson.eto.norarc.ejbactorframe.messages.RoleCreateMsg;
import se.ericsson.eto.norarc.ejbframe.ActorAddress;
import se.ericsson.eto.norarc.ejbframe.Simulator;
import console.gui.MgtConsole;
import java.util.List;
import se.ericsson.eto.norarc.ejbframe.Scheduler;

/**
 * This class is necessary to be able to simulate beans outside the container. 
 * // TODO adjust to UML 2.0
 */

public class MySimulator {

	private static Scheduler sim = new Scheduler();
	private String [] fqns =  new String[79];

	public static void main(String argv[]) {
		new MySimulator();

	}

	public MySimulator() {
		
	
sim.addStateMachine(new SimServiceRegistrySM(), "ServiceRegistry");
sim.addStateMachine(new SimLocationSensorSM(), "LocationSensor");
sim.addStateMachine(new SimTerminalAgentSM(), "TerminalAgent");
sim.addStateMachine(new SimPolicyStoreSM(), "PolicyStore");
sim.addStateMachine(new SimNRGCallControlFeatureSM(), "NRGCallControlFeature");
sim.addStateMachine(new SimNRGLocationFeatureSM(), "NRGLocationFeature");
sim.addStateMachine(new SimTerminalPolicyEditorSM(), "TerminalPolicyEditor");
sim.addStateMachine(new SimProfileEditorSM(), "ProfileEditor");
sim.addStateMachine(new SimPolicyManagerSM(), "PolicyManager");
sim.addStateMachine(new SimPolicyEditorSM(), "PolicyEditor");
sim.addStateMachine(new SimCBCCUserAgentSM(), "CBCCUserAgent");
sim.addStateMachine(new SimUserTerminalSessionSM(), "UserTerminalSession");
sim.addStateMachine(new SimUserAgentSM(), "UserAgent");
sim.addStateMachine(new SimContextEngineSM(), "ContextEngine");
sim.addStateMachine(new SimCallControllerSM(), "CallController");
sim.addStateMachine(new SimTerminalClientSessionSM(), "TerminalClientSession");
fqns[0] ="no.ntnu.item.serviceframe.signals.addpolicy.AddOnUnsRBPolicyMsg";
fqns[1] ="no.ntnu.item.serviceframe.signals.serviceregistry.ServiceRegistrationNotificationMsg";
fqns[2] ="no.ntnu.item.serviceframe.signals.knownroles.KnownRolesResultMsg";
fqns[3] ="no.ntnu.item.serviceframe.signals.getpolicylist.CollaborationPolicyListReplyMsg";
fqns[4] ="no.ntnu.item.serviceframe.signals.serviceregistry.RegServiceMsg";
fqns[5] ="no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg";
fqns[6] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.OnRRPolicyMsg";
fqns[7] ="no.ntnu.item.serviceframe.signals.agentprofile.ProfileMsg";
fqns[8] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.OnNonAGPolicyMsg";
fqns[9] ="no.ntnu.item.serviceframe.signals.terminalclientlogon.LogonReq";
fqns[10] ="no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg";
fqns[11] ="no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyNOKMsg";
fqns[12] ="no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationInvalid";
fqns[13] ="no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnGnotAReqMsg";
fqns[14] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationRes";
fqns[15] ="no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyOKMsg";
fqns[16] ="no.ntnu.item.serviceframe.signals.terminalclientlogout.LogoutReq";
fqns[17] ="no.ntnu.item.mam.signals.common.RouteRes";
fqns[18] ="no.ntnu.item.serviceframe.signals.getpolicylist.CollaborationPolicyListReqMsg";
fqns[19] ="no.ntnu.item.serviceframe.signals.terminalclientlogon.LogonRes";
fqns[20] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnRRPolicyListReqMsg";
fqns[21] ="no.ntnu.item.serviceframe.signals.init.InitMsg";
fqns[22] ="no.ntnu.item.cbcc.cbccuseragent.signals.StartUp";
fqns[23] ="no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyNOKMsg";
fqns[24] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.CollaborationPolicyMsg";
fqns[25] ="no.ntnu.item.serviceframe.signals.init.InitConfMsg";
fqns[26] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.PolicyInsertionOkMsg";
fqns[27] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnRRPolicyListReplyMsg";
fqns[28] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReqMsg";
fqns[29] ="no.ntnu.item.serviceframe.signals.serviceregistry.LookupServicesResultMsg";
fqns[30] ="no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOKMsg";
fqns[31] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.StopSubscriptions";
fqns[32] ="no.ntnu.item.mam.signals.ccnrgedgeservice.HandleCall";
fqns[33] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.TimeIsUp";
fqns[34] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.RegisterLocationReqSubscriptions";
fqns[35] ="no.ntnu.item.serviceframe.signals.policycheck.GoalNotAchievedMsg";
fqns[36] ="no.ntnu.item.contextengine.signals.StartUpContextEngine";
fqns[37] ="no.ntnu.item.serviceframe.signals.agentprofile.ProfileLoadRequestMsg";
fqns[38] ="no.ntnu.item.serviceframe.signals.addpolicy.AddCollaborationPolicyMsg";
fqns[39] ="no.ntnu.item.serviceframe.signals.addpolicy.AddRBPolicyMsg";
fqns[40] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationReceived";
fqns[41] ="no.ntnu.item.serviceframe.signals.terminalclientlogon.LogonErr";
fqns[42] ="no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg";
fqns[43] ="no.ntnu.item.contextengine.signals.ContextUpdate";
fqns[44] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.LocationSubscriptionReport";
fqns[45] ="no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReplyMsg";
fqns[46] ="no.ntnu.item.serviceframe.signals.deletepolicy.DeletePolicyReqMsg";
fqns[47] ="no.ntnu.item.mam.signals.common.RouteReq";
fqns[48] ="no.ntnu.item.serviceframe.signals.serviceregistry.RegServiceAckMsg";
fqns[49] ="no.ntnu.item.serviceframe.signals.servicelist.ServiceListResultMsg";
fqns[50] ="no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationReq";
fqns[51] ="no.ntnu.item.serviceframe.signals.getpolicylist.RoleBindingPolicyListReqMsg";
fqns[52] ="no.ntnu.item.serviceframe.signals.handshake.HelloMsg";
fqns[53] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnUnsRBPolicyListReplyMsg";
fqns[54] ="no.ntnu.item.serviceframe.signals.serviceregistry.ServiceRegistrationNotificationAckMsg";
fqns[55] ="no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReqMsg";
fqns[56] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnNonAGPolicyListReplyMsg";
fqns[57] ="no.ntnu.item.serviceframe.signals.knownroles.KnownRolesReqMsg";
fqns[58] ="no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg";
fqns[59] ="no.ntnu.item.serviceframe.signals.servicelist.ServiceListReqMsg";
fqns[60] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.StopFetching";
fqns[61] ="no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionDeniedMsg";
fqns[62] ="no.ntnu.item.serviceframe.signals.serviceregistry.ServiceRegistrationNotificationReqMsg";
fqns[63] ="no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckOnRRReqMsg";
fqns[64] ="no.ntnu.item.serviceframe.signals.handshake.HelloHelloMsg";
fqns[65] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.OnUnsRBPolicyMsg";
fqns[66] ="no.ntnu.item.serviceframe.signals.insertpolicyobject.RoleBindingPolicyMsg";
fqns[67] ="no.ntnu.item.serviceframe.signals.useragentauthentication.UserAuthenticationValid";
fqns[68] ="no.ntnu.item.serviceframe.signals.addpolicy.AddOnNonAGPolicyMsg";
fqns[69] ="no.ntnu.item.serviceframe.signals.agentprofile.ProfileUpdateMsg";
fqns[70] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.StartFetching";
fqns[71] ="no.ntnu.item.serviceframe.signals.policycheck.PolicyCheckNOKMsg";
fqns[72] ="no.ntnu.item.serviceframe.signals.getpolicylist.OnNonAGPolicyListReqMsg";
fqns[73] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.FetchLocationReq";
fqns[74] ="no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReplyMsg";
fqns[75] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.LocationSensorRegistered";
fqns[76] ="no.ntnu.item.serviceframe.signals.serviceregistry.LookupServicesMsg";
fqns[77] ="no.ntnu.item.contextengine.sensors.locationsensor.locationfetcher.signals.StopLocationReqSubscriptions";
fqns[78] ="no.ntnu.item.contextengine.sensors.locationsensor.signals.StartSubscriptions";
		
		Runnable rr = new Runnable() {
			public void run() {
			
MgtConsole.main(fqns);
			}
		};
		new Thread(rr).start();
		RoleCreateMsg rcm = new RoleCreateMsg(); // create only one instance
		rcm.setReceiverRole(new ActorAddress("ua", "CBCCUserAgent"));
		rcm.setSenderRole(new ActorAddress(null, null));
		Scheduler.output(rcm,null);
	}

}