package no.ntnu.item.serviceframe.actors.policymanagement.policyeditor;

import no.ntnu.item.serviceframe.auxiliar.policyobjects.CollaborationPolicyObject;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.OnNonAchGoalFSPolicyObject;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.OnRRFSPolicyObject;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.OnUnsRoleBindingFSPolicyObject;
import no.ntnu.item.serviceframe.auxiliar.policyobjects.RoleBindingPolicyObject;
import no.ntnu.item.serviceframe.signals.addpolicy.AddCollaborationPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnNonAGPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnUnsRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.CollaborationPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnNonAGPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnUnsRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.RoleBindingPolicyMsg;

import java.util.ArrayList;
import java.util.Hashtable;

import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionConfMsg;
import no.ntnu.item.serviceframe.signals.servicesession.ServiceSessionReqMsg;
import no.ntnu.item.serviceframe.signals.handshake.HelloHelloMsg;
import no.ntnu.item.serviceframe.signals.handshake.HelloMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReqMsg;

public class PolicyEditorActions extends Object {

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnRRPolicy(AddOnRRPolicyMsg signal, PolicyEditorSM asm){
    	OnRRFSPolicyObject obj = new OnRRFSPolicyObject(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ConditionText);
    	OnRRPolicyMsg onrr = new OnRRPolicyMsg(obj);
    	asm.requestorSessionRole = signal.getSenderRole();
    	asm.sendMessage(onrr, "policyStorePort");
    	//asm.sendMessage(onrr, new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnNon(AddOnNonAGPolicyMsg signal, PolicyEditorSM asm){
    	OnNonAchGoalFSPolicyObject obj = new OnNonAchGoalFSPolicyObject(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ConditionText);
    	OnNonAGPolicyMsg onnon = new OnNonAGPolicyMsg(obj);
    	asm.requestorSessionRole = signal.getSenderRole();
    	asm.sendMessage(onnon, "policyStorePort");
    	//asm.sendMessage(onnon, new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnUns(AddOnUnsRBPolicyMsg signal, PolicyEditorSM asm){
        OnUnsRoleBindingFSPolicyObject obj = new OnUnsRoleBindingFSPolicyObject(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ConditionText);
    	OnUnsRBPolicyMsg onuns = new OnUnsRBPolicyMsg(obj);
    	asm.requestorSessionRole = signal.getSenderRole();
    	asm.sendMessage(onuns, "policyStorePort");
    	//asm.sendMessage(onuns, new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddRuntime(AddCollaborationPolicyMsg signal, PolicyEditorSM asm){
        CollaborationPolicyObject obj = new CollaborationPolicyObject(signal.SubjectRole, signal.PolicyType, signal.Condition, signal.ConditionText);
    	CollaborationPolicyMsg runtime = new CollaborationPolicyMsg(obj);
    	asm.requestorSessionRole = signal.getSenderRole();
    	asm.sendMessage(runtime, "policyStorePort");
    	//asm.sendMessage(runtime, new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddInv(AddRBPolicyMsg signal, PolicyEditorSM asm){
        RoleBindingPolicyObject obj = new RoleBindingPolicyObject(signal.SubjectRole, signal.PolicyType, signal.Condition, signal.ConditionText);
    	RoleBindingPolicyMsg inv = new RoleBindingPolicyMsg(obj);
    	asm.requestorSessionRole = signal.getSenderRole();
    	asm.sendMessage(inv, "policyStorePort");
    	//asm.sendMessage(inv, new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddPolicyOk(AddPolicyOkMsg signal, PolicyEditorSM asm){
    	asm.sendMessage(signal, asm.requestorSessionRole);
    }

	public static void sendSSC(ServiceSessionReqMsg signal, PolicyEditorSM asm){
		Hashtable actorRefs = new Hashtable();
		actorRefs.put("PolicyEditor", asm.getMyActorAddress());
		ServiceSessionConfMsg sscm = new ServiceSessionConfMsg(signal.serviceIDs, signal.roleRequestors, new Hashtable(), actorRefs);

		if (sscm.roleRequestors != null && sscm.roleRequestors.size()>0) {
			//search the incomming serviceID and roleRequestor list and check if we can provide any of the requested roles
			for(int i=0;i<sscm.serviceIDs.size();i++) {
				for(int j=0;j<sscm.roleRequestors.size();j++) {
					String serviceID = (String) sscm.serviceIDs.get(i);
					String requestingActorType = (String) sscm.roleRequestors.get(j);
					String key = serviceID+"."+requestingActorType;
					String roleType = (String) asm.knownRoles.get(key);
					if(roleType!=null) sscm.roleProposals.put(serviceID+"."+requestingActorType, roleType);
				}
			}
		}
    	asm.sendMessage(sscm, signal.getSenderRole());
	}

	public static void sendHelloHello(HelloMsg signal, PolicyEditorSM asm){
    	asm.sendMessage(new HelloHelloMsg(new ArrayList(), null, asm.getMyActorAddress()), signal.getSenderRole());
	}


	public static void forwardGetPoliciesReply(GetPoliciesReplyMsg signal, PolicyEditorSM asm){
	    asm.sendMessage(new GetPoliciesReplyMsg(signal.policyType, signal.subjectRole, signal.policyList), asm.requestorSessionRole);
	}


	public static void forwardGetPoliciesReq(GetPoliciesReqMsg signal, PolicyEditorSM asm){
    	asm.requestorSessionRole = signal.getSenderRole();
	    //asm.sendMessage(new GetPoliciesReqMsg(signal.policyType, signal.subjectRole), new ActorAddress(asm.context.getParentAddress().getActorID()+"/policyStore", "PolicyStore"));
    	asm.sendMessage(new GetPoliciesReqMsg(signal.policyType, signal.subjectRole), "policyStorePort");
	}


	
	


	
}
