package no.ntnu.item.serviceframe.actors.policymanagement.policystore;


import java.util.ArrayList;

import no.ntnu.item.serviceframe.auxiliar.policyobjects.PolicyObjectsStoringFacility;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.CollaborationArrayListReplyMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.CollaborationArrayListReqMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnNonAGArrayListReplyMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnNonAGArrayListReqMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnRRArrayListReplyMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnRRArrayListReqMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnUnsRBArrayListReplyMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.OnUnsRBArrayListReqMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.RoleBindingArrayListReplyMsg;
import no.ntnu.item.serviceframe.signals.getarraylist.RoleBindingArrayListReqMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReqMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.CollaborationPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnNonAGPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.OnUnsRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.insertpolicyobject.RoleBindingPolicyMsg;
public class PolicyStoreActions extends Object {



    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnRROk(OnRRPolicyMsg signal, PolicyStoreSM asm){
    	ArrayList a = (ArrayList) asm.OnRoleRequestHashtable.get(signal.onrr.getSubject());
    	if (a == null) a = new ArrayList();
    	a.add(signal.onrr);
   		asm.OnRoleRequestHashtable.put(signal.onrr.getSubject(), a);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnRoleRequest", asm.username, asm.OnRoleRequestHashtable);
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnNonAGOk(OnNonAGPolicyMsg signal, PolicyStoreSM asm){
    	ArrayList a = (ArrayList) asm.OnNonAGHashtable.get(signal.onnon.getSubject());
    	if (a == null) a = new ArrayList();
    	a.add(signal.onnon);
   		asm.OnNonAGHashtable.put(signal.onnon.getSubject(), a);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnNonAchievedRoleGoal", asm.username, asm.OnNonAGHashtable);
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertRBOk(RoleBindingPolicyMsg signal, PolicyStoreSM asm){
    	ArrayList a = (ArrayList) asm.RoleBindingHashtable.get(signal.inv.getSubject());
    	if (a == null) a = new ArrayList();
    	a.add(signal.inv);
   		asm.RoleBindingHashtable.put(signal.inv.getSubject(), a);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("RoleBinding", asm.username, asm.RoleBindingHashtable);
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertCollaborationOk(CollaborationPolicyMsg signal, PolicyStoreSM asm){
    	ArrayList a = (ArrayList) asm.CollaborationHashtable.get(signal.runt.getSubject());
    	if (a == null) a = new ArrayList();
    	a.add(signal.runt);
   		asm.CollaborationHashtable.put(signal.runt.getSubject(), a);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("Collaboration", asm.username, asm.CollaborationHashtable);
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendInsertOnUnsRBOk(OnUnsRBPolicyMsg signal, PolicyStoreSM asm){
    	ArrayList a = (ArrayList) asm.OnUnsRBHashtable.get(signal.onuns.getSubject());
    	if (a == null) a = new ArrayList();
    	a.add(signal.onuns);
   		asm.OnUnsRBHashtable.put(signal.onuns.getSubject(), a);
   		PolicyObjectsStoringFacility.savePolicyObjectsToDisk("OnUnsuccessfulRoleBinding", asm.username, asm.OnUnsRBHashtable);
    	asm.sendMessage(new AddPolicyOkMsg(), signal.getSenderRole());
    }

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnRRArrayListReply(OnRRArrayListReqMsg signal, PolicyStoreSM asm){
		System.out.println("**************** "+signal.role);
		asm.sendMessage(new OnRRArrayListReplyMsg(
				(ArrayList)asm.OnRoleRequestHashtable.get(signal.role), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnUnsRBArrayListReply(OnUnsRBArrayListReqMsg signal, PolicyStoreSM asm){
		asm.sendMessage(new OnUnsRBArrayListReplyMsg(
				(ArrayList)asm.OnUnsRBHashtable.get(signal.role), signal.role),
				signal.getSenderRole());
    }

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendOnNonAGArrayListReply(OnNonAGArrayListReqMsg signal, PolicyStoreSM asm){
		asm.sendMessage(new OnNonAGArrayListReplyMsg(
				(ArrayList)asm.OnNonAGHashtable.get(signal.role), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendCollaborationArrayListReply(CollaborationArrayListReqMsg signal, PolicyStoreSM asm){
		asm.sendMessage(new CollaborationArrayListReplyMsg(
				(ArrayList)asm.CollaborationHashtable.get(signal.role), signal.role),
				signal.getSenderRole());
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void sendRoleBindingArrayListReply(RoleBindingArrayListReqMsg signal, PolicyStoreSM asm){
		asm.sendMessage(new RoleBindingArrayListReplyMsg(
				(ArrayList)asm.RoleBindingHashtable.get(signal.role), signal.role),
				signal.getSenderRole());
    }


	public static void sendPolicies(GetPoliciesReqMsg signal, PolicyStoreSM asm){
		ArrayList list=null;
		if (signal.policyType.equalsIgnoreCase("RoleBinding")) {
			list = (ArrayList) asm.RoleBindingHashtable.get(signal.subjectRole); 
		}
		else if (signal.policyType.equalsIgnoreCase("Collaboration")) {
			list = (ArrayList) asm.CollaborationHashtable.get(signal.subjectRole); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnRoleRequest")) {
			list = (ArrayList) asm.OnRoleRequestHashtable.get(signal.subjectRole); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnUnsuccessfulRoleBinding")) {
			list = (ArrayList) asm.OnUnsRBHashtable.get(signal.subjectRole); 
		}
		else if (signal.policyType.equalsIgnoreCase("OnNonAchievedRoleGoal")) {
			list = (ArrayList) asm.OnNonAGHashtable.get(signal.subjectRole); 
		}
		asm.sendMessage(new GetPoliciesReplyMsg(signal.policyType, signal.subjectRole, list), signal.getSenderRole());
	}

}
