package no.ntnu.item.serviceframe.actors.policymanagement.terminalpolicyeditor;

import no.ntnu.item.serviceframe.signals.addpolicy.AddCollaborationPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnNonAGPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnRRPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddOnUnsRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddPolicyOkMsg;
import no.ntnu.item.serviceframe.signals.addpolicy.AddRBPolicyMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReplyMsg;
import no.ntnu.item.serviceframe.signals.getpolicies.GetPoliciesReqMsg;
import no.ntnu.item.serviceframe.signals.handshake.HelloHelloMsg;
import no.ntnu.item.serviceframe.signals.handshake.HelloMsg;
import no.ntnu.item.serviceframe.signals.init.InitConfMsg;
import no.ntnu.item.serviceframe.signals.init.InitMsg;


public class TerminalPolicyEditorActions extends Object {

    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnRRPolicy(AddOnRRPolicyMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddOnRRPolicyMsg(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ParametersText), asm.requestedRole);

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnNon(AddOnNonAGPolicyMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddOnNonAGPolicyMsg(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ParametersText), asm.requestedRole);

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddOnUns(AddOnUnsRBPolicyMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddOnUnsRBPolicyMsg(signal.SubjectRole, signal.PolicyType,
    			signal.Condition, signal.AlternativeRole, signal.Parameters, signal.ConditionText, signal.ParametersText), asm.requestedRole);
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddRuntime(AddCollaborationPolicyMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddCollaborationPolicyMsg(signal.SubjectRole, signal.PolicyType, signal.Condition, signal.ConditionText), asm.requestedRole);

    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddInv(AddRBPolicyMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddRBPolicyMsg(signal.SubjectRole, signal.PolicyType, signal.Condition, signal.ConditionText), asm.requestedRole);
    }


    /*
     * source vertex: idle
     * target vertex: idle
     */
    public static void forwardAddPolicyOk(AddPolicyOkMsg signal, TerminalPolicyEditorSM asm){
    	asm.sendMessage(new AddPolicyOkMsg(), asm.requestorRole);
    }

    public static void sendHello(InitMsg signal, TerminalPolicyEditorSM asm){
    	asm.savedInitMsg = signal;
    	asm.requestedRole = signal.address;
    	asm.sendMessage(new HelloMsg(signal.username), signal.address);
    }


	public static void sendInitConf(HelloHelloMsg signal, TerminalPolicyEditorSM asm){
		asm.sendMessage(new InitConfMsg(asm.getMyActorAddress()), asm.savedInitMsg.getSenderRole());
	}


	public static void sendHelloHello(HelloMsg signal, TerminalPolicyEditorSM asm){
    	asm.requestorRole = signal.getSenderRole();
    	asm.sendMessage(new HelloHelloMsg(null, null, asm.getMyActorAddress()), signal.getSenderRole());
	}


	public static void forwardGetPoliciesReq(GetPoliciesReqMsg signal, TerminalPolicyEditorSM asm){
	    asm.sendMessage(new GetPoliciesReqMsg(signal.policyType, signal.subjectRole), asm.requestedRole);
	}


	public static void forwardGetPoliciesReply(GetPoliciesReplyMsg signal, TerminalPolicyEditorSM asm){
	    asm.sendMessage(new GetPoliciesReplyMsg(signal.policyType, signal.subjectRole, signal.policyList), asm.requestorRole);
	}

}
