package no.ntnu.item.serviceframe.auxiliar.agentprofile;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

public class AgentProfile implements Serializable{

	
	/*
	 * The following method stores an object of (super-)type AgentProfile  in a file
	 */
		public boolean saveToDisk(String profileID) {
			// Use a FileOutputStream to send data to a file
			// called AgentProfile_<profileID>.data
			FileOutputStream f_out;
			try {
				f_out = new FileOutputStream("AgentProfile_"+ profileID + ".data");
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
				System.out.println(e.getMessage());
				//e.printStackTrace();
				System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
				return false;
			}
			
			// Use an ObjectOutputStream to send object data to the
			// FileOutputStream for writing to disk.
			ObjectOutputStream obj_out = null;
			try {
				obj_out = new ObjectOutputStream(f_out);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
				System.out.println(e.getMessage());
				//e.printStackTrace();
				System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
				return false;
			}
			
			// Pass our object to the ObjectOutputStream's
			// writeObject() method to cause it to be written out
			// to disk.
			try {
				obj_out.writeObject(this);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
				System.out.println(e.getMessage());
				//e.printStackTrace();
				System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
				return false;
			}
			return true;
		}

		/*
		 * The following method reads an object of (super-)type AgentProfile from a file
		 */
			public static AgentProfile readFromDisk(String profileID) {

				// Read from disk using FileInputStream.
				FileInputStream f_in;
				try {
					f_in = new FileInputStream("AgentProfile_"+ profileID + ".data");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
					System.out.println(e.getMessage());
					//e.printStackTrace();
					System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
					return null;
				}
				
				// Read object using ObjectInputStream.
				ObjectInputStream obj_in;
				try {
					obj_in = new ObjectInputStream(f_in);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
					System.out.println(e.getMessage());
					//e.printStackTrace();
					System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
					return null;
				}
				
				// Read an object.
				try {
					return (AgentProfile)obj_in.readObject();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
					System.out.println(e.getMessage());
					//e.printStackTrace();
					System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
					return null;
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					System.out.println("<<<<<<<<<<<<<< Exception caught >>>>>>>>>>>>>>>>>>>");
					System.out.println(e.getMessage());
					//e.printStackTrace();
					System.out.println("<<<<<<<<<<<<<< End of Exception >>>>>>>>>>>>>>>>>>>");
					return null;
				}
			}


}
